#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 467
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 141
#define ALIAS_COUNT 2
#define TOKEN_COUNT 80
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 4
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 24

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_alias = 2,
  anon_sym_COLON_EQ = 3,
  anon_sym_export = 4,
  anon_sym_import = 5,
  anon_sym_QMARK = 6,
  anon_sym_mod = 7,
  anon_sym_AT = 8,
  anon_sym_COLON = 9,
  anon_sym_AMP_AMP = 10,
  anon_sym_LBRACK = 11,
  anon_sym_COMMA = 12,
  anon_sym_RBRACK = 13,
  anon_sym_LPAREN = 14,
  anon_sym_RPAREN = 15,
  anon_sym_DOLLAR = 16,
  anon_sym_EQ = 17,
  anon_sym_PLUS = 18,
  anon_sym_STAR = 19,
  aux_sym_shebang_line_token1 = 20,
  anon_sym_AT_DASH = 21,
  anon_sym_DASH_AT = 22,
  anon_sym_POUND_BANG_SLASHusr_SLASHbin_SLASHenv = 23,
  aux_sym_shebang_line_token2 = 24,
  sym_shebang_shell = 25,
  anon_sym_DASH = 26,
  anon_sym_LBRACE_LBRACE_LBRACE_LBRACE = 27,
  aux_sym__recipe_line_choice_token1 = 28,
  anon_sym_LBRACE_LBRACE = 29,
  anon_sym_RBRACE_RBRACE = 30,
  anon_sym_set = 31,
  anon_sym_shell = 32,
  anon_sym_true = 33,
  anon_sym_false = 34,
  anon_sym_if = 35,
  anon_sym_LBRACE = 36,
  anon_sym_RBRACE = 37,
  anon_sym_else = 38,
  anon_sym_assert = 39,
  anon_sym_SLASH = 40,
  anon_sym_EQ_EQ = 41,
  anon_sym_BANG_EQ = 42,
  anon_sym_EQ_TILDE = 43,
  anon_sym_BQUOTE = 44,
  aux_sym__backtick_token1 = 45,
  anon_sym_BQUOTE_BQUOTE_BQUOTE = 46,
  aux_sym__indented_backtick_token1 = 47,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 48,
  aux_sym__indented_normal_string_token1 = 49,
  anon_sym_DQUOTE = 50,
  aux_sym__normal_string_token1 = 51,
  anon_sym_SQUOTE_SQUOTE_SQUOTE = 52,
  aux_sym__indented_raw_string_token1 = 53,
  anon_sym_SQUOTE = 54,
  aux_sym__raw_string_token1 = 55,
  anon_sym_BSLASHn = 56,
  anon_sym_BSLASHr = 57,
  anon_sym_BSLASHt = 58,
  anon_sym_BSLASH_DQUOTE = 59,
  anon_sym_BSLASH_BSLASH = 60,
  anon_sym_x_DQUOTE_DQUOTE_DQUOTE = 61,
  aux_sym__shell_expanded_indented_normal_string_token1 = 62,
  aux_sym__shell_expanded_indented_normal_string_token2 = 63,
  anon_sym_x_DQUOTE = 64,
  aux_sym__shell_expanded_normal_string_token1 = 65,
  aux_sym__shell_expanded_normal_string_token2 = 66,
  anon_sym_x_SQUOTE_SQUOTE_SQUOTE = 67,
  aux_sym__shell_expanded_indented_raw_string_token1 = 68,
  anon_sym_x_SQUOTE = 69,
  aux_sym__shell_expanded_raw_string_token1 = 70,
  aux_sym__shell_expanded_raw_string_token2 = 71,
  sym_shell_variable_name = 72,
  sym_escape_variable_end = 73,
  sym_expansion_long_start = 74,
  sym_expansion_long_middle = 75,
  sym_expansion_long_end = 76,
  aux_sym_comment_token1 = 77,
  sym__eol = 78,
  sym_numeric_error = 79,
  sym_file = 80,
  sym_alias = 81,
  sym_assignment = 82,
  sym_import = 83,
  sym_mod = 84,
  sym_recipe = 85,
  sym_recipe_parameters = 86,
  sym__attribute_list = 87,
  sym_attribute = 88,
  sym_recipe_parameter = 89,
  sym_variadic_parameter = 90,
  sym_recipe_dependency = 91,
  sym__recipe_dependency = 92,
  sym_recipe_body = 93,
  sym_shebang_line = 94,
  sym_recipe_line = 95,
  sym__recipe_line_choice = 96,
  sym_interpolation = 97,
  sym_setting = 98,
  sym__setting_boolean = 99,
  sym__setting_string = 100,
  sym__setting_list = 101,
  sym_boolean = 102,
  sym_expression = 103,
  sym_condition = 104,
  sym_assert_parameters = 105,
  sym_value = 106,
  sym_function_call = 107,
  sym_function_parameters = 108,
  sym_external_command = 109,
  sym__backtick = 110,
  sym__indented_backtick = 111,
  sym_string = 112,
  sym_shell_expanded_string = 113,
  sym_escape_sequence = 114,
  sym_expansion_short_start = 115,
  sym_comment = 116,
  sym__ceol = 117,
  aux_sym_file_repeat1 = 118,
  aux_sym_alias_repeat1 = 119,
  aux_sym_recipe_repeat1 = 120,
  aux_sym_recipe_parameters_repeat1 = 121,
  aux_sym__attribute_list_repeat1 = 122,
  aux_sym_recipe_dependency_repeat1 = 123,
  aux_sym_recipe_body_repeat1 = 124,
  aux_sym_shebang_line_repeat1 = 125,
  aux_sym_shebang_line_repeat2 = 126,
  aux_sym__setting_list_repeat1 = 127,
  aux_sym_function_parameters_repeat1 = 128,
  aux_sym__indented_backtick_repeat1 = 129,
  aux_sym__indented_normal_string_repeat1 = 130,
  aux_sym__normal_string_repeat1 = 131,
  aux_sym__indented_raw_string_repeat1 = 132,
  aux_sym__shell_expanded_indented_normal_string_repeat1 = 133,
  aux_sym__shell_expanded_indented_normal_string_repeat2 = 134,
  aux_sym__shell_expanded_normal_string_repeat1 = 135,
  aux_sym__shell_expanded_normal_string_repeat2 = 136,
  aux_sym__shell_expanded_indented_raw_string_repeat1 = 137,
  aux_sym__shell_expanded_indented_raw_string_repeat2 = 138,
  aux_sym__shell_expanded_raw_string_repeat1 = 139,
  aux_sym__shell_expanded_raw_string_repeat2 = 140,
  alias_sym_path = 141,
  alias_sym_regex = 142,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_alias] = "alias",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_export] = "export",
  [anon_sym_import] = "import",
  [anon_sym_QMARK] = "\?",
  [anon_sym_mod] = "mod",
  [anon_sym_AT] = "@",
  [anon_sym_COLON] = ":",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LBRACK] = "[",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [aux_sym_shebang_line_token1] = "shebang_line_token1",
  [anon_sym_AT_DASH] = "@-",
  [anon_sym_DASH_AT] = "-@",
  [anon_sym_POUND_BANG_SLASHusr_SLASHbin_SLASHenv] = "#!/usr/bin/env",
  [aux_sym_shebang_line_token2] = "shebang_line_token2",
  [sym_shebang_shell] = "shebang_shell",
  [anon_sym_DASH] = "-",
  [anon_sym_LBRACE_LBRACE_LBRACE_LBRACE] = "{{{{",
  [aux_sym__recipe_line_choice_token1] = "_recipe_line_choice_token1",
  [anon_sym_LBRACE_LBRACE] = "{{",
  [anon_sym_RBRACE_RBRACE] = "}}",
  [anon_sym_set] = "set",
  [anon_sym_shell] = "shell",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_if] = "if",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_else] = "else",
  [anon_sym_assert] = "assert",
  [anon_sym_SLASH] = "/",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BQUOTE] = "`",
  [aux_sym__backtick_token1] = "content",
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = "```",
  [aux_sym__indented_backtick_token1] = "_indented_backtick_token1",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [aux_sym__indented_normal_string_token1] = "_indented_normal_string_token1",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym__normal_string_token1] = "_normal_string_token1",
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = "'''",
  [aux_sym__indented_raw_string_token1] = "_indented_raw_string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym__raw_string_token1] = "_raw_string_token1",
  [anon_sym_BSLASHn] = "\\n",
  [anon_sym_BSLASHr] = "\\r",
  [anon_sym_BSLASHt] = "\\t",
  [anon_sym_BSLASH_DQUOTE] = "\\\"",
  [anon_sym_BSLASH_BSLASH] = "\\\\",
  [anon_sym_x_DQUOTE_DQUOTE_DQUOTE] = "x\"\"\"",
  [aux_sym__shell_expanded_indented_normal_string_token1] = "_shell_expanded_indented_normal_string_token1",
  [aux_sym__shell_expanded_indented_normal_string_token2] = "_shell_expanded_indented_normal_string_token2",
  [anon_sym_x_DQUOTE] = "x\"",
  [aux_sym__shell_expanded_normal_string_token1] = "_shell_expanded_normal_string_token1",
  [aux_sym__shell_expanded_normal_string_token2] = "_shell_expanded_normal_string_token2",
  [anon_sym_x_SQUOTE_SQUOTE_SQUOTE] = "x'''",
  [aux_sym__shell_expanded_indented_raw_string_token1] = "_shell_expanded_indented_raw_string_token1",
  [anon_sym_x_SQUOTE] = "x'",
  [aux_sym__shell_expanded_raw_string_token1] = "_shell_expanded_raw_string_token1",
  [aux_sym__shell_expanded_raw_string_token2] = "_shell_expanded_raw_string_token2",
  [sym_shell_variable_name] = "shell_variable_name",
  [sym_escape_variable_end] = "escape_variable_end",
  [sym_expansion_long_start] = "expansion_long_start",
  [sym_expansion_long_middle] = "expansion_long_middle",
  [sym_expansion_long_end] = "expansion_long_end",
  [aux_sym_comment_token1] = "comment_token1",
  [sym__eol] = "_eol",
  [sym_numeric_error] = "numeric_error",
  [sym_file] = "file",
  [sym_alias] = "alias",
  [sym_assignment] = "assignment",
  [sym_import] = "import",
  [sym_mod] = "mod",
  [sym_recipe] = "recipe",
  [sym_recipe_parameters] = "recipe_parameters",
  [sym__attribute_list] = "_attribute_list",
  [sym_attribute] = "attribute",
  [sym_recipe_parameter] = "recipe_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_recipe_dependency] = "recipe_dependency",
  [sym__recipe_dependency] = "_recipe_dependency",
  [sym_recipe_body] = "recipe_body",
  [sym_shebang_line] = "shebang_line",
  [sym_recipe_line] = "recipe_line",
  [sym__recipe_line_choice] = "_recipe_line_choice",
  [sym_interpolation] = "interpolation",
  [sym_setting] = "setting",
  [sym__setting_boolean] = "_setting_boolean",
  [sym__setting_string] = "_setting_string",
  [sym__setting_list] = "_setting_list",
  [sym_boolean] = "boolean",
  [sym_expression] = "expression",
  [sym_condition] = "condition",
  [sym_assert_parameters] = "assert_parameters",
  [sym_value] = "value",
  [sym_function_call] = "function_call",
  [sym_function_parameters] = "function_parameters",
  [sym_external_command] = "external_command",
  [sym__backtick] = "_backtick",
  [sym__indented_backtick] = "_indented_backtick",
  [sym_string] = "string",
  [sym_shell_expanded_string] = "shell_expanded_string",
  [sym_escape_sequence] = "escape_sequence",
  [sym_expansion_short_start] = "expansion_short_start",
  [sym_comment] = "comment",
  [sym__ceol] = "_ceol",
  [aux_sym_file_repeat1] = "file_repeat1",
  [aux_sym_alias_repeat1] = "alias_repeat1",
  [aux_sym_recipe_repeat1] = "recipe_repeat1",
  [aux_sym_recipe_parameters_repeat1] = "recipe_parameters_repeat1",
  [aux_sym__attribute_list_repeat1] = "_attribute_list_repeat1",
  [aux_sym_recipe_dependency_repeat1] = "recipe_dependency_repeat1",
  [aux_sym_recipe_body_repeat1] = "recipe_body_repeat1",
  [aux_sym_shebang_line_repeat1] = "shebang_line_repeat1",
  [aux_sym_shebang_line_repeat2] = "shebang_line_repeat2",
  [aux_sym__setting_list_repeat1] = "_setting_list_repeat1",
  [aux_sym_function_parameters_repeat1] = "function_parameters_repeat1",
  [aux_sym__indented_backtick_repeat1] = "_indented_backtick_repeat1",
  [aux_sym__indented_normal_string_repeat1] = "_indented_normal_string_repeat1",
  [aux_sym__normal_string_repeat1] = "_normal_string_repeat1",
  [aux_sym__indented_raw_string_repeat1] = "_indented_raw_string_repeat1",
  [aux_sym__shell_expanded_indented_normal_string_repeat1] = "_shell_expanded_indented_normal_string_repeat1",
  [aux_sym__shell_expanded_indented_normal_string_repeat2] = "_shell_expanded_indented_normal_string_repeat2",
  [aux_sym__shell_expanded_normal_string_repeat1] = "_shell_expanded_normal_string_repeat1",
  [aux_sym__shell_expanded_normal_string_repeat2] = "_shell_expanded_normal_string_repeat2",
  [aux_sym__shell_expanded_indented_raw_string_repeat1] = "_shell_expanded_indented_raw_string_repeat1",
  [aux_sym__shell_expanded_indented_raw_string_repeat2] = "_shell_expanded_indented_raw_string_repeat2",
  [aux_sym__shell_expanded_raw_string_repeat1] = "_shell_expanded_raw_string_repeat1",
  [aux_sym__shell_expanded_raw_string_repeat2] = "_shell_expanded_raw_string_repeat2",
  [alias_sym_path] = "path",
  [alias_sym_regex] = "regex",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_alias] = anon_sym_alias,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [aux_sym_shebang_line_token1] = aux_sym_shebang_line_token1,
  [anon_sym_AT_DASH] = anon_sym_AT_DASH,
  [anon_sym_DASH_AT] = anon_sym_DASH_AT,
  [anon_sym_POUND_BANG_SLASHusr_SLASHbin_SLASHenv] = anon_sym_POUND_BANG_SLASHusr_SLASHbin_SLASHenv,
  [aux_sym_shebang_line_token2] = aux_sym_shebang_line_token2,
  [sym_shebang_shell] = sym_shebang_shell,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_LBRACE_LBRACE_LBRACE_LBRACE] = anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
  [aux_sym__recipe_line_choice_token1] = aux_sym__recipe_line_choice_token1,
  [anon_sym_LBRACE_LBRACE] = anon_sym_LBRACE_LBRACE,
  [anon_sym_RBRACE_RBRACE] = anon_sym_RBRACE_RBRACE,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_shell] = anon_sym_shell,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_EQ_TILDE] = anon_sym_EQ_TILDE,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [aux_sym__backtick_token1] = aux_sym__backtick_token1,
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = anon_sym_BQUOTE_BQUOTE_BQUOTE,
  [aux_sym__indented_backtick_token1] = aux_sym__indented_backtick_token1,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [aux_sym__indented_normal_string_token1] = aux_sym__indented_normal_string_token1,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym__normal_string_token1] = aux_sym__normal_string_token1,
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = anon_sym_SQUOTE_SQUOTE_SQUOTE,
  [aux_sym__indented_raw_string_token1] = aux_sym__indented_raw_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym__raw_string_token1] = aux_sym__raw_string_token1,
  [anon_sym_BSLASHn] = anon_sym_BSLASHn,
  [anon_sym_BSLASHr] = anon_sym_BSLASHr,
  [anon_sym_BSLASHt] = anon_sym_BSLASHt,
  [anon_sym_BSLASH_DQUOTE] = anon_sym_BSLASH_DQUOTE,
  [anon_sym_BSLASH_BSLASH] = anon_sym_BSLASH_BSLASH,
  [anon_sym_x_DQUOTE_DQUOTE_DQUOTE] = anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
  [aux_sym__shell_expanded_indented_normal_string_token1] = aux_sym__shell_expanded_indented_normal_string_token1,
  [aux_sym__shell_expanded_indented_normal_string_token2] = aux_sym__shell_expanded_indented_normal_string_token2,
  [anon_sym_x_DQUOTE] = anon_sym_x_DQUOTE,
  [aux_sym__shell_expanded_normal_string_token1] = aux_sym__shell_expanded_normal_string_token1,
  [aux_sym__shell_expanded_normal_string_token2] = aux_sym__shell_expanded_normal_string_token2,
  [anon_sym_x_SQUOTE_SQUOTE_SQUOTE] = anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
  [aux_sym__shell_expanded_indented_raw_string_token1] = aux_sym__shell_expanded_indented_raw_string_token1,
  [anon_sym_x_SQUOTE] = anon_sym_x_SQUOTE,
  [aux_sym__shell_expanded_raw_string_token1] = aux_sym__shell_expanded_raw_string_token1,
  [aux_sym__shell_expanded_raw_string_token2] = aux_sym__shell_expanded_raw_string_token2,
  [sym_shell_variable_name] = sym_shell_variable_name,
  [sym_escape_variable_end] = sym_escape_variable_end,
  [sym_expansion_long_start] = sym_expansion_long_start,
  [sym_expansion_long_middle] = sym_expansion_long_middle,
  [sym_expansion_long_end] = sym_expansion_long_end,
  [aux_sym_comment_token1] = aux_sym_comment_token1,
  [sym__eol] = sym__eol,
  [sym_numeric_error] = sym_numeric_error,
  [sym_file] = sym_file,
  [sym_alias] = sym_alias,
  [sym_assignment] = sym_assignment,
  [sym_import] = sym_import,
  [sym_mod] = sym_mod,
  [sym_recipe] = sym_recipe,
  [sym_recipe_parameters] = sym_recipe_parameters,
  [sym__attribute_list] = sym__attribute_list,
  [sym_attribute] = sym_attribute,
  [sym_recipe_parameter] = sym_recipe_parameter,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym_recipe_dependency] = sym_recipe_dependency,
  [sym__recipe_dependency] = sym__recipe_dependency,
  [sym_recipe_body] = sym_recipe_body,
  [sym_shebang_line] = sym_shebang_line,
  [sym_recipe_line] = sym_recipe_line,
  [sym__recipe_line_choice] = sym__recipe_line_choice,
  [sym_interpolation] = sym_interpolation,
  [sym_setting] = sym_setting,
  [sym__setting_boolean] = sym__setting_boolean,
  [sym__setting_string] = sym__setting_string,
  [sym__setting_list] = sym__setting_list,
  [sym_boolean] = sym_boolean,
  [sym_expression] = sym_expression,
  [sym_condition] = sym_condition,
  [sym_assert_parameters] = sym_assert_parameters,
  [sym_value] = sym_value,
  [sym_function_call] = sym_function_call,
  [sym_function_parameters] = sym_function_parameters,
  [sym_external_command] = sym_external_command,
  [sym__backtick] = sym__backtick,
  [sym__indented_backtick] = sym__indented_backtick,
  [sym_string] = sym_string,
  [sym_shell_expanded_string] = sym_shell_expanded_string,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_expansion_short_start] = sym_expansion_short_start,
  [sym_comment] = sym_comment,
  [sym__ceol] = sym__ceol,
  [aux_sym_file_repeat1] = aux_sym_file_repeat1,
  [aux_sym_alias_repeat1] = aux_sym_alias_repeat1,
  [aux_sym_recipe_repeat1] = aux_sym_recipe_repeat1,
  [aux_sym_recipe_parameters_repeat1] = aux_sym_recipe_parameters_repeat1,
  [aux_sym__attribute_list_repeat1] = aux_sym__attribute_list_repeat1,
  [aux_sym_recipe_dependency_repeat1] = aux_sym_recipe_dependency_repeat1,
  [aux_sym_recipe_body_repeat1] = aux_sym_recipe_body_repeat1,
  [aux_sym_shebang_line_repeat1] = aux_sym_shebang_line_repeat1,
  [aux_sym_shebang_line_repeat2] = aux_sym_shebang_line_repeat2,
  [aux_sym__setting_list_repeat1] = aux_sym__setting_list_repeat1,
  [aux_sym_function_parameters_repeat1] = aux_sym_function_parameters_repeat1,
  [aux_sym__indented_backtick_repeat1] = aux_sym__indented_backtick_repeat1,
  [aux_sym__indented_normal_string_repeat1] = aux_sym__indented_normal_string_repeat1,
  [aux_sym__normal_string_repeat1] = aux_sym__normal_string_repeat1,
  [aux_sym__indented_raw_string_repeat1] = aux_sym__indented_raw_string_repeat1,
  [aux_sym__shell_expanded_indented_normal_string_repeat1] = aux_sym__shell_expanded_indented_normal_string_repeat1,
  [aux_sym__shell_expanded_indented_normal_string_repeat2] = aux_sym__shell_expanded_indented_normal_string_repeat2,
  [aux_sym__shell_expanded_normal_string_repeat1] = aux_sym__shell_expanded_normal_string_repeat1,
  [aux_sym__shell_expanded_normal_string_repeat2] = aux_sym__shell_expanded_normal_string_repeat2,
  [aux_sym__shell_expanded_indented_raw_string_repeat1] = aux_sym__shell_expanded_indented_raw_string_repeat1,
  [aux_sym__shell_expanded_indented_raw_string_repeat2] = aux_sym__shell_expanded_indented_raw_string_repeat2,
  [aux_sym__shell_expanded_raw_string_repeat1] = aux_sym__shell_expanded_raw_string_repeat1,
  [aux_sym__shell_expanded_raw_string_repeat2] = aux_sym__shell_expanded_raw_string_repeat2,
  [alias_sym_path] = alias_sym_path,
  [alias_sym_regex] = alias_sym_regex,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_shebang_line_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_AT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_BANG_SLASHusr_SLASHbin_SLASHenv] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_shebang_line_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_shebang_shell] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_LBRACE_LBRACE_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__recipe_line_choice_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACE_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shell] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__backtick_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__indented_backtick_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__indented_normal_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__normal_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__indented_raw_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__raw_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASHn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__shell_expanded_indented_normal_string_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__shell_expanded_indented_normal_string_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_x_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__shell_expanded_normal_string_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__shell_expanded_normal_string_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_x_SQUOTE_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__shell_expanded_indented_raw_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_x_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__shell_expanded_raw_string_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__shell_expanded_raw_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_shell_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_variable_end] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion_long_start] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion_long_middle] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion_long_end] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__eol] = {
    .visible = false,
    .named = true,
  },
  [sym_numeric_error] = {
    .visible = true,
    .named = true,
  },
  [sym_file] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_mod] = {
    .visible = true,
    .named = true,
  },
  [sym_recipe] = {
    .visible = true,
    .named = true,
  },
  [sym_recipe_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute_list] = {
    .visible = false,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_recipe_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_recipe_dependency] = {
    .visible = true,
    .named = true,
  },
  [sym__recipe_dependency] = {
    .visible = false,
    .named = true,
  },
  [sym_recipe_body] = {
    .visible = true,
    .named = true,
  },
  [sym_shebang_line] = {
    .visible = true,
    .named = true,
  },
  [sym_recipe_line] = {
    .visible = true,
    .named = true,
  },
  [sym__recipe_line_choice] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_setting] = {
    .visible = true,
    .named = true,
  },
  [sym__setting_boolean] = {
    .visible = false,
    .named = true,
  },
  [sym__setting_string] = {
    .visible = false,
    .named = true,
  },
  [sym__setting_list] = {
    .visible = false,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_value] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_external_command] = {
    .visible = true,
    .named = true,
  },
  [sym__backtick] = {
    .visible = false,
    .named = true,
  },
  [sym__indented_backtick] = {
    .visible = false,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_shell_expanded_string] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion_short_start] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__ceol] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alias_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_recipe_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_recipe_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__attribute_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_recipe_dependency_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_recipe_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_shebang_line_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_shebang_line_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__setting_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__indented_backtick_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__indented_normal_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__normal_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__indented_raw_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__shell_expanded_indented_normal_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__shell_expanded_indented_normal_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__shell_expanded_normal_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__shell_expanded_normal_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__shell_expanded_indented_raw_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__shell_expanded_indented_raw_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__shell_expanded_raw_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__shell_expanded_raw_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_path] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_regex] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_interpolation_marker = 1,
  field_name = 2,
  field_recipe_content = 3,
  field_shebang = 4,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_interpolation_marker] = "interpolation_marker",
  [field_name] = "name",
  [field_recipe_content] = "recipe_content",
  [field_shebang] = "shebang",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 1},
  [7] = {.index = 1, .length = 1},
  [8] = {.index = 4, .length = 1},
  [9] = {.index = 3, .length = 1},
  [11] = {.index = 5, .length = 1},
  [12] = {.index = 6, .length = 1},
  [13] = {.index = 7, .length = 1},
  [14] = {.index = 8, .length = 1},
  [16] = {.index = 9, .length = 1},
  [17] = {.index = 10, .length = 2},
  [18] = {.index = 8, .length = 1},
  [19] = {.index = 12, .length = 1},
  [20] = {.index = 13, .length = 2},
  [21] = {.index = 15, .length = 1},
  [22] = {.index = 16, .length = 1},
  [23] = {.index = 17, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_name, 1},
  [2] =
    {field_name, 0, .inherited = true},
  [3] =
    {field_name, 2},
  [4] =
    {field_shebang, 0},
  [5] =
    {field_name, 1, .inherited = true},
  [6] =
    {field_recipe_content, 0},
  [7] =
    {field_recipe_content, 0, .inherited = true},
  [8] =
    {field_name, 3},
  [9] =
    {field_recipe_content, 1, .inherited = true},
  [10] =
    {field_recipe_content, 0, .inherited = true},
    {field_recipe_content, 1, .inherited = true},
  [12] =
    {field_recipe_content, 2, .inherited = true},
  [13] =
    {field_interpolation_marker, 0},
    {field_interpolation_marker, 2},
  [15] =
    {field_recipe_content, 3, .inherited = true},
  [16] =
    {field_recipe_content, 4, .inherited = true},
  [17] =
    {field_recipe_content, 5, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [1] = alias_sym_path,
  },
  [5] = {
    [2] = alias_sym_path,
  },
  [7] = {
    [2] = alias_sym_path,
  },
  [9] = {
    [3] = alias_sym_path,
  },
  [10] = {
    [1] = aux_sym__backtick_token1,
  },
  [15] = {
    [2] = alias_sym_regex,
  },
  [18] = {
    [4] = alias_sym_path,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_expression, 2,
    sym_expression,
    alias_sym_regex,
  sym_string, 2,
    sym_string,
    alias_sym_path,
  aux_sym__indented_backtick_repeat1, 2,
    aux_sym__indented_backtick_repeat1,
    aux_sym__backtick_token1,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 2,
  [5] = 2,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 8,
  [10] = 8,
  [11] = 11,
  [12] = 11,
  [13] = 13,
  [14] = 11,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 18,
  [23] = 20,
  [24] = 24,
  [25] = 19,
  [26] = 18,
  [27] = 27,
  [28] = 24,
  [29] = 29,
  [30] = 20,
  [31] = 24,
  [32] = 20,
  [33] = 33,
  [34] = 34,
  [35] = 19,
  [36] = 29,
  [37] = 17,
  [38] = 29,
  [39] = 17,
  [40] = 40,
  [41] = 17,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 50,
  [82] = 53,
  [83] = 55,
  [84] = 84,
  [85] = 56,
  [86] = 52,
  [87] = 58,
  [88] = 88,
  [89] = 61,
  [90] = 90,
  [91] = 60,
  [92] = 92,
  [93] = 92,
  [94] = 51,
  [95] = 95,
  [96] = 57,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 92,
  [101] = 101,
  [102] = 102,
  [103] = 88,
  [104] = 62,
  [105] = 54,
  [106] = 88,
  [107] = 59,
  [108] = 63,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 111,
  [113] = 113,
  [114] = 113,
  [115] = 113,
  [116] = 111,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 126,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 64,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 200,
  [202] = 202,
  [203] = 203,
  [204] = 202,
  [205] = 205,
  [206] = 192,
  [207] = 190,
  [208] = 208,
  [209] = 209,
  [210] = 174,
  [211] = 190,
  [212] = 192,
  [213] = 200,
  [214] = 202,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 174,
  [224] = 174,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 174,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 174,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 245,
  [250] = 246,
  [251] = 251,
  [252] = 252,
  [253] = 248,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 247,
  [258] = 246,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 248,
  [265] = 245,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 247,
  [271] = 271,
  [272] = 272,
  [273] = 126,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 65,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 52,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 54,
  [300] = 300,
  [301] = 50,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 58,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 56,
  [319] = 62,
  [320] = 320,
  [321] = 59,
  [322] = 322,
  [323] = 63,
  [324] = 324,
  [325] = 60,
  [326] = 326,
  [327] = 305,
  [328] = 328,
  [329] = 329,
  [330] = 305,
  [331] = 57,
  [332] = 64,
  [333] = 333,
  [334] = 307,
  [335] = 51,
  [336] = 336,
  [337] = 307,
  [338] = 300,
  [339] = 61,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 304,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 304,
  [352] = 352,
  [353] = 55,
  [354] = 64,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 300,
  [359] = 53,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 367,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 367,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 44,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 45,
  [399] = 399,
  [400] = 397,
  [401] = 401,
  [402] = 402,
  [403] = 392,
  [404] = 42,
  [405] = 401,
  [406] = 387,
  [407] = 396,
  [408] = 408,
  [409] = 408,
  [410] = 410,
  [411] = 43,
  [412] = 412,
  [413] = 43,
  [414] = 414,
  [415] = 415,
  [416] = 45,
  [417] = 42,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 44,
  [424] = 397,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 392,
  [430] = 430,
  [431] = 410,
  [432] = 432,
  [433] = 387,
  [434] = 396,
  [435] = 435,
  [436] = 436,
  [437] = 408,
  [438] = 410,
  [439] = 401,
  [440] = 440,
  [441] = 440,
  [442] = 442,
  [443] = 399,
  [444] = 444,
  [445] = 445,
  [446] = 440,
  [447] = 447,
  [448] = 399,
  [449] = 449,
  [450] = 450,
  [451] = 421,
  [452] = 419,
  [453] = 421,
  [454] = 419,
  [455] = 455,
  [456] = 432,
  [457] = 457,
  [458] = 432,
  [459] = 414,
  [460] = 414,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 463,
  [465] = 177,
  [466] = 463,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(59);
      ADVANCE_MAP(
        '\n', 194,
        '\r', 1,
        '!', 40,
        '"', 127,
        '#', 29,
        '$', 75,
        '&', 33,
        '\'', 139,
        '(', 72,
        ')', 73,
        '*', 79,
        '+', 78,
        ',', 70,
        '-', 86,
        '/', 104,
        ':', 66,
        '=', 77,
        '?', 61,
        '@', 63,
        '[', 69,
        '\\', 30,
        ']', 71,
        '`', 109,
        'x', 191,
        '{', 102,
        '}', 190,
      );
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(55);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(194);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '\n', 194,
        '\r', 1,
        '!', 40,
        '"', 127,
        '#', 193,
        '\'', 139,
        '(', 72,
        ')', 73,
        ',', 70,
        '/', 104,
        '=', 41,
        '`', 109,
        'x', 191,
        '{', 101,
        '}', 103,
      );
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(2);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '\n', 194,
        '\r', 1,
        '"', 127,
        '\'', 139,
        '(', 72,
        ')', 73,
        '+', 78,
        '/', 104,
        '`', 109,
        'x', 191,
        '}', 53,
      );
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(3);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == '$') ADVANCE(74);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(78);
      if (lookahead == ':') ADVANCE(65);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == '-') ADVANCE(54);
      if (lookahead == ':') ADVANCE(36);
      if (lookahead == '}') ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(6);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(85);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == '-') ADVANCE(54);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(6);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(85);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(7);
      END_STATE();
    case 8:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(7);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '\n', 194,
        '\r', 90,
        '#', 95,
        '-', 87,
        '@', 64,
        '{', 97,
        '\t', 91,
        ' ', 91,
      );
      if (lookahead != 0) ADVANCE(98);
      END_STATE();
    case 10:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(90);
      if (lookahead == '#') ADVANCE(95);
      if (lookahead == '{') ADVANCE(97);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(92);
      if (lookahead != 0) ADVANCE(98);
      END_STATE();
    case 11:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(90);
      if (lookahead == '-') ADVANCE(87);
      if (lookahead == '@') ADVANCE(64);
      if (lookahead == '{') ADVANCE(97);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(93);
      if (lookahead != 0) ADVANCE(98);
      END_STATE();
    case 12:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(90);
      if (lookahead == '{') ADVANCE(97);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(94);
      if (lookahead != 0) ADVANCE(98);
      END_STATE();
    case 13:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(122);
      if (lookahead == '"') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(121);
      if (lookahead != 0) ADVANCE(125);
      END_STATE();
    case 14:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(135);
      if (lookahead == '\'') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(134);
      if (lookahead != 0) ADVANCE(137);
      END_STATE();
    case 15:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(116);
      if (lookahead == '`') ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(115);
      if (lookahead != 0) ADVANCE(118);
      END_STATE();
    case 16:
      if (lookahead == '\n') ADVANCE(160);
      if (lookahead == '\r') ADVANCE(157);
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(185);
      if (lookahead != 0) ADVANCE(160);
      END_STATE();
    case 17:
      if (lookahead == '\n') ADVANCE(160);
      if (lookahead == '\r') ADVANCE(157);
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(156);
      if (lookahead != 0) ADVANCE(160);
      END_STATE();
    case 18:
      if (lookahead == '\n') ADVANCE(166);
      if (lookahead == '\r') ADVANCE(167);
      if (lookahead == '"') ADVANCE(126);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(168);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0) ADVANCE(166);
      END_STATE();
    case 19:
      if (lookahead == '\n') ADVANCE(166);
      if (lookahead == '\r') ADVANCE(167);
      if (lookahead == '"') ADVANCE(126);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(168);
      if (lookahead != 0) ADVANCE(166);
      END_STATE();
    case 20:
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r') ADVANCE(163);
      if (lookahead == '\\') ADVANCE(165);
      if (lookahead == '}') ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(162);
      END_STATE();
    case 21:
      if (lookahead == '\n') ADVANCE(149);
      if (lookahead == '\r') ADVANCE(150);
      if (lookahead == '\\') ADVANCE(153);
      if (lookahead == '}') ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(151);
      if (lookahead != 0) ADVANCE(149);
      END_STATE();
    case 22:
      if (lookahead == '\n') ADVANCE(149);
      if (lookahead == '\r') ADVANCE(150);
      if (lookahead == '\\') ADVANCE(154);
      if (lookahead == '}') ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(152);
      if (lookahead != 0) ADVANCE(149);
      END_STATE();
    case 23:
      if (lookahead == '\n') ADVANCE(128);
      if (lookahead == '\r') ADVANCE(129);
      if (lookahead == '"') ADVANCE(126);
      if (lookahead == '\\') ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(130);
      if (lookahead != 0) ADVANCE(128);
      END_STATE();
    case 24:
      if (lookahead == '\n') ADVANCE(181);
      if (lookahead == '\r') ADVANCE(182);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '\'') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(183);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0) ADVANCE(181);
      END_STATE();
    case 25:
      if (lookahead == '\n') ADVANCE(181);
      if (lookahead == '\r') ADVANCE(182);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '\'') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(183);
      if (lookahead != 0) ADVANCE(181);
      END_STATE();
    case 26:
      if (lookahead == '\n') ADVANCE(175);
      if (lookahead == '\r') ADVANCE(173);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0) ADVANCE(175);
      END_STATE();
    case 27:
      if (lookahead == '\n') ADVANCE(175);
      if (lookahead == '\r') ADVANCE(173);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(172);
      if (lookahead != 0) ADVANCE(175);
      END_STATE();
    case 28:
      if (lookahead == '\n') ADVANCE(177);
      if (lookahead == '\r') ADVANCE(178);
      if (lookahead == '\\') ADVANCE(180);
      if (lookahead == '}') ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(177);
      END_STATE();
    case 29:
      if (lookahead == '!') ADVANCE(37);
      END_STATE();
    case 30:
      if (lookahead == '"') ADVANCE(146);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead == 'r') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      if (lookahead == '}') ADVANCE(187);
      END_STATE();
    case 31:
      if (lookahead == '"') ADVANCE(119);
      END_STATE();
    case 32:
      if (lookahead == '"') ADVANCE(148);
      END_STATE();
    case 33:
      if (lookahead == '&') ADVANCE(68);
      END_STATE();
    case 34:
      if (lookahead == '\'') ADVANCE(132);
      END_STATE();
    case 35:
      if (lookahead == '\'') ADVANCE(170);
      END_STATE();
    case 36:
      if (lookahead == '-') ADVANCE(189);
      END_STATE();
    case 37:
      if (lookahead == '/') ADVANCE(50);
      END_STATE();
    case 38:
      if (lookahead == '/') ADVANCE(43);
      END_STATE();
    case 39:
      if (lookahead == '/') ADVANCE(44);
      END_STATE();
    case 40:
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 41:
      if (lookahead == '=') ADVANCE(105);
      if (lookahead == '~') ADVANCE(107);
      END_STATE();
    case 42:
      if (lookahead == '`') ADVANCE(113);
      END_STATE();
    case 43:
      if (lookahead == 'b') ADVANCE(45);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 45:
      if (lookahead == 'i') ADVANCE(47);
      END_STATE();
    case 46:
      if (lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 47:
      if (lookahead == 'n') ADVANCE(39);
      END_STATE();
    case 48:
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 49:
      if (lookahead == 's') ADVANCE(48);
      END_STATE();
    case 50:
      if (lookahead == 'u') ADVANCE(49);
      END_STATE();
    case 51:
      if (lookahead == 'v') ADVANCE(83);
      END_STATE();
    case 52:
      if (lookahead == '{') ADVANCE(88);
      END_STATE();
    case 53:
      if (lookahead == '}') ADVANCE(100);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(84);
      END_STATE();
    case 55:
      if (eof) ADVANCE(59);
      ADVANCE_MAP(
        '\n', 194,
        '\r', 1,
        '!', 40,
        '"', 127,
        '#', 29,
        '$', 75,
        '&', 33,
        '\'', 139,
        '(', 72,
        ')', 73,
        '*', 79,
        '+', 78,
        ',', 70,
        '-', 86,
        '/', 104,
        ':', 67,
        '=', 77,
        '@', 63,
        '[', 69,
        '\\', 30,
        ']', 71,
        '`', 109,
        'x', 191,
        '{', 102,
        '}', 103,
      );
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(55);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 56:
      if (eof) ADVANCE(59);
      ADVANCE_MAP(
        '\n', 194,
        '\r', 1,
        '!', 40,
        '#', 193,
        '$', 74,
        '&', 33,
        '\'', 138,
        '(', 72,
        ')', 73,
        '*', 79,
        '+', 78,
        ',', 70,
        '/', 104,
        ':', 67,
        '=', 41,
        '?', 61,
        '@', 62,
        '[', 69,
        ']', 71,
        '`', 108,
        '{', 101,
        '}', 103,
      );
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(57);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 57:
      if (eof) ADVANCE(59);
      ADVANCE_MAP(
        '\n', 194,
        '\r', 1,
        '!', 40,
        '#', 193,
        '$', 74,
        '&', 33,
        '\'', 138,
        '(', 72,
        ')', 73,
        '*', 79,
        '+', 78,
        ',', 70,
        '/', 104,
        ':', 67,
        '=', 41,
        '@', 62,
        '[', 69,
        ']', 71,
        '`', 108,
        '{', 101,
        '}', 103,
      );
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(57);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 58:
      if (eof) ADVANCE(59);
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == '#') ADVANCE(193);
      if (lookahead == '@') ADVANCE(62);
      if (lookahead == '[') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(80);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '-') ADVANCE(81);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '-') ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(89);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '=') ADVANCE(60);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(60);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{') ADVANCE(188);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(105);
      if (lookahead == '~') ADVANCE(107);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(aux_sym_shebang_line_token1);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_AT_DASH);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DASH_AT);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_POUND_BANG_SLASHusr_SLASHbin_SLASHenv);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym_shebang_line_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_shebang_shell);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(85);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '@') ADVANCE(82);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '@') ADVANCE(82);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(89);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_LBRACE_LBRACE_LBRACE_LBRACE);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(aux_sym__recipe_line_choice_token1);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(aux_sym__recipe_line_choice_token1);
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(89);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(aux_sym__recipe_line_choice_token1);
      if (lookahead == '\r') ADVANCE(90);
      if (lookahead == '#') ADVANCE(95);
      if (lookahead == '-') ADVANCE(87);
      if (lookahead == '@') ADVANCE(64);
      if (lookahead == '{') ADVANCE(97);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(91);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n') ADVANCE(98);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym__recipe_line_choice_token1);
      if (lookahead == '\r') ADVANCE(90);
      if (lookahead == '#') ADVANCE(95);
      if (lookahead == '{') ADVANCE(97);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n') ADVANCE(98);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym__recipe_line_choice_token1);
      if (lookahead == '\r') ADVANCE(90);
      if (lookahead == '-') ADVANCE(87);
      if (lookahead == '@') ADVANCE(64);
      if (lookahead == '{') ADVANCE(97);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n') ADVANCE(98);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym__recipe_line_choice_token1);
      if (lookahead == '\r') ADVANCE(90);
      if (lookahead == '{') ADVANCE(97);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n') ADVANCE(98);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym__recipe_line_choice_token1);
      if (lookahead == '!') ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(89);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym__recipe_line_choice_token1);
      if (lookahead == '/') ADVANCE(50);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym__recipe_line_choice_token1);
      if (lookahead == '{') ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(89);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(aux_sym__recipe_line_choice_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(89);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_LBRACE_LBRACE);
      if (lookahead == '{') ADVANCE(52);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_RBRACE_RBRACE);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '{') ADVANCE(99);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead == '`') ADVANCE(42);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(aux_sym__backtick_token1);
      if (lookahead == '\n') ADVANCE(112);
      if (lookahead == '\r') ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(110);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(112);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym__backtick_token1);
      if (lookahead == '\n') ADVANCE(112);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(112);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(aux_sym__backtick_token1);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(112);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_BQUOTE_BQUOTE_BQUOTE);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym__indented_backtick_token1);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym__indented_backtick_token1);
      if (lookahead == '\n') ADVANCE(114);
      if (lookahead == '\r') ADVANCE(116);
      if (lookahead == '`') ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(115);
      if (lookahead != 0) ADVANCE(118);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym__indented_backtick_token1);
      if (lookahead == '\n') ADVANCE(114);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(114);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym__indented_backtick_token1);
      if (lookahead == '`') ADVANCE(42);
      if (lookahead != 0) ADVANCE(114);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym__indented_backtick_token1);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(114);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym__indented_normal_string_token1);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym__indented_normal_string_token1);
      if (lookahead == '\n') ADVANCE(120);
      if (lookahead == '\r') ADVANCE(122);
      if (lookahead == '"') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(121);
      if (lookahead != 0) ADVANCE(125);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(aux_sym__indented_normal_string_token1);
      if (lookahead == '\n') ADVANCE(120);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(120);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(aux_sym__indented_normal_string_token1);
      if (lookahead == '"') ADVANCE(31);
      if (lookahead != 0) ADVANCE(120);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym__indented_normal_string_token1);
      if (lookahead == '"') ADVANCE(146);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead == 'r') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      if (lookahead != 0) ADVANCE(120);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym__indented_normal_string_token1);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(120);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(31);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym__normal_string_token1);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym__normal_string_token1);
      if (lookahead == '\n') ADVANCE(194);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(aux_sym__normal_string_token1);
      if (lookahead == '\n') ADVANCE(128);
      if (lookahead == '\r') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(130);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(128);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(aux_sym__normal_string_token1);
      if (lookahead == '"') ADVANCE(146);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead == 'r') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE_SQUOTE);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(aux_sym__indented_raw_string_token1);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym__indented_raw_string_token1);
      if (lookahead == '\n') ADVANCE(133);
      if (lookahead == '\r') ADVANCE(135);
      if (lookahead == '\'') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(134);
      if (lookahead != 0) ADVANCE(137);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym__indented_raw_string_token1);
      if (lookahead == '\n') ADVANCE(133);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(133);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym__indented_raw_string_token1);
      if (lookahead == '\'') ADVANCE(34);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym__indented_raw_string_token1);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(133);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(34);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym__raw_string_token1);
      if (lookahead == '\n') ADVANCE(142);
      if (lookahead == '\r') ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(140);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(142);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym__raw_string_token1);
      if (lookahead == '\n') ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(142);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym__raw_string_token1);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_BSLASHn);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_BSLASHr);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_BSLASHt);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_BSLASH_DQUOTE);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_BSLASH_BSLASH);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_x_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token1);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token1);
      if (lookahead == '\n') ADVANCE(194);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token1);
      if (lookahead == '\n') ADVANCE(149);
      if (lookahead == '\r') ADVANCE(150);
      if (lookahead == '\\') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(151);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(149);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token1);
      if (lookahead == '\n') ADVANCE(149);
      if (lookahead == '\r') ADVANCE(150);
      if (lookahead == '\\') ADVANCE(154);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(149);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token1);
      if (lookahead == '"') ADVANCE(146);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead == 'r') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      if (lookahead == '}') ADVANCE(187);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token1);
      if (lookahead == '}') ADVANCE(187);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token2);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token2);
      if (lookahead == '\n') ADVANCE(160);
      if (lookahead == '\r') ADVANCE(157);
      if (lookahead == '"') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '$') ADVANCE(160);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token2);
      if (lookahead == '\n') ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$') ADVANCE(155);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token2);
      if (lookahead == '"') ADVANCE(31);
      if (lookahead != 0 &&
          lookahead != '$') ADVANCE(155);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token2);
      if (lookahead == '"') ADVANCE(146);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead == 'r') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      if (lookahead == '}') ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '$') ADVANCE(155);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_normal_string_token2);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$') ADVANCE(155);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_x_DQUOTE);
      if (lookahead == '"') ADVANCE(32);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym__shell_expanded_normal_string_token1);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym__shell_expanded_normal_string_token1);
      if (lookahead == '\n') ADVANCE(194);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym__shell_expanded_normal_string_token1);
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r') ADVANCE(163);
      if (lookahead == '\\') ADVANCE(165);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(162);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym__shell_expanded_normal_string_token1);
      if (lookahead == '"') ADVANCE(146);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead == 'r') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      if (lookahead == '}') ADVANCE(187);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym__shell_expanded_normal_string_token2);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym__shell_expanded_normal_string_token2);
      if (lookahead == '\n') ADVANCE(194);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym__shell_expanded_normal_string_token2);
      if (lookahead == '\n') ADVANCE(166);
      if (lookahead == '\r') ADVANCE(167);
      if (lookahead == '\\') ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$') ADVANCE(166);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym__shell_expanded_normal_string_token2);
      if (lookahead == '"') ADVANCE(146);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead == 'r') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_x_SQUOTE_SQUOTE_SQUOTE);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_raw_string_token1);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_raw_string_token1);
      if (lookahead == '\n') ADVANCE(175);
      if (lookahead == '\r') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '$') ADVANCE(175);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_raw_string_token1);
      if (lookahead == '\n') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(171);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_raw_string_token1);
      if (lookahead == '\'') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '$') ADVANCE(171);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym__shell_expanded_indented_raw_string_token1);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(171);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_x_SQUOTE);
      if (lookahead == '\'') ADVANCE(35);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(aux_sym__shell_expanded_raw_string_token1);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(aux_sym__shell_expanded_raw_string_token1);
      if (lookahead == '\n') ADVANCE(194);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(aux_sym__shell_expanded_raw_string_token1);
      if (lookahead == '\n') ADVANCE(177);
      if (lookahead == '\r') ADVANCE(178);
      if (lookahead == '\\') ADVANCE(180);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '}') ADVANCE(177);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(aux_sym__shell_expanded_raw_string_token1);
      if (lookahead == '}') ADVANCE(187);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(aux_sym__shell_expanded_raw_string_token2);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(aux_sym__shell_expanded_raw_string_token2);
      if (lookahead == '\n') ADVANCE(194);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(aux_sym__shell_expanded_raw_string_token2);
      if (lookahead == '\n') ADVANCE(181);
      if (lookahead == '\r') ADVANCE(182);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(181);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_shell_variable_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_shell_variable_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$') ADVANCE(155);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_shell_variable_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(171);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_escape_variable_end);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_expansion_long_start);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_expansion_long_middle);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_expansion_long_end);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym__eol);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_numeric_error);
      if (lookahead == '.') ADVANCE(196);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_numeric_error);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(196);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'e') ADVANCE(2);
      if (lookahead == 'f') ADVANCE(3);
      if (lookahead == 'i') ADVANCE(4);
      if (lookahead == 'm') ADVANCE(5);
      if (lookahead == 's') ADVANCE(6);
      if (lookahead == 't') ADVANCE(7);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 's') ADVANCE(9);
      END_STATE();
    case 2:
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'x') ADVANCE(11);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(12);
      END_STATE();
    case 4:
      if (lookahead == 'f') ADVANCE(13);
      if (lookahead == 'm') ADVANCE(14);
      END_STATE();
    case 5:
      if (lookahead == 'o') ADVANCE(15);
      END_STATE();
    case 6:
      if (lookahead == 'e') ADVANCE(16);
      if (lookahead == 'h') ADVANCE(17);
      END_STATE();
    case 7:
      if (lookahead == 'r') ADVANCE(18);
      END_STATE();
    case 8:
      if (lookahead == 'i') ADVANCE(19);
      END_STATE();
    case 9:
      if (lookahead == 's') ADVANCE(20);
      END_STATE();
    case 10:
      if (lookahead == 's') ADVANCE(21);
      END_STATE();
    case 11:
      if (lookahead == 'p') ADVANCE(22);
      END_STATE();
    case 12:
      if (lookahead == 'l') ADVANCE(23);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 14:
      if (lookahead == 'p') ADVANCE(24);
      END_STATE();
    case 15:
      if (lookahead == 'd') ADVANCE(25);
      END_STATE();
    case 16:
      if (lookahead == 't') ADVANCE(26);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(27);
      END_STATE();
    case 18:
      if (lookahead == 'u') ADVANCE(28);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(29);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(30);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(31);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(33);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_mod);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 27:
      if (lookahead == 'l') ADVANCE(35);
      END_STATE();
    case 28:
      if (lookahead == 'e') ADVANCE(36);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(37);
      END_STATE();
    case 30:
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 32:
      if (lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 33:
      if (lookahead == 'e') ADVANCE(40);
      END_STATE();
    case 34:
      if (lookahead == 'r') ADVANCE(41);
      END_STATE();
    case 35:
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(44);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_shell);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 56},
  [2] = {.lex_state = 0},
  [3] = {.lex_state = 0},
  [4] = {.lex_state = 0},
  [5] = {.lex_state = 0},
  [6] = {.lex_state = 0},
  [7] = {.lex_state = 0},
  [8] = {.lex_state = 0},
  [9] = {.lex_state = 0},
  [10] = {.lex_state = 0},
  [11] = {.lex_state = 0},
  [12] = {.lex_state = 0},
  [13] = {.lex_state = 0},
  [14] = {.lex_state = 0},
  [15] = {.lex_state = 0},
  [16] = {.lex_state = 0},
  [17] = {.lex_state = 0},
  [18] = {.lex_state = 0},
  [19] = {.lex_state = 0},
  [20] = {.lex_state = 0},
  [21] = {.lex_state = 0},
  [22] = {.lex_state = 0},
  [23] = {.lex_state = 0},
  [24] = {.lex_state = 0},
  [25] = {.lex_state = 0},
  [26] = {.lex_state = 0},
  [27] = {.lex_state = 0},
  [28] = {.lex_state = 0},
  [29] = {.lex_state = 0},
  [30] = {.lex_state = 0},
  [31] = {.lex_state = 0},
  [32] = {.lex_state = 0},
  [33] = {.lex_state = 0},
  [34] = {.lex_state = 0},
  [35] = {.lex_state = 0},
  [36] = {.lex_state = 0},
  [37] = {.lex_state = 0},
  [38] = {.lex_state = 0},
  [39] = {.lex_state = 0},
  [40] = {.lex_state = 0},
  [41] = {.lex_state = 0},
  [42] = {.lex_state = 2},
  [43] = {.lex_state = 2},
  [44] = {.lex_state = 2},
  [45] = {.lex_state = 2},
  [46] = {.lex_state = 0},
  [47] = {.lex_state = 0},
  [48] = {.lex_state = 56},
  [49] = {.lex_state = 56},
  [50] = {.lex_state = 3},
  [51] = {.lex_state = 3},
  [52] = {.lex_state = 3},
  [53] = {.lex_state = 3},
  [54] = {.lex_state = 3},
  [55] = {.lex_state = 3},
  [56] = {.lex_state = 3},
  [57] = {.lex_state = 3},
  [58] = {.lex_state = 3},
  [59] = {.lex_state = 3},
  [60] = {.lex_state = 3},
  [61] = {.lex_state = 3},
  [62] = {.lex_state = 3},
  [63] = {.lex_state = 3},
  [64] = {.lex_state = 0},
  [65] = {.lex_state = 0},
  [66] = {.lex_state = 58},
  [67] = {.lex_state = 58},
  [68] = {.lex_state = 58},
  [69] = {.lex_state = 58},
  [70] = {.lex_state = 58},
  [71] = {.lex_state = 58},
  [72] = {.lex_state = 58},
  [73] = {.lex_state = 58},
  [74] = {.lex_state = 58},
  [75] = {.lex_state = 58},
  [76] = {.lex_state = 58},
  [77] = {.lex_state = 58},
  [78] = {.lex_state = 58},
  [79] = {.lex_state = 58},
  [80] = {.lex_state = 58},
  [81] = {.lex_state = 56},
  [82] = {.lex_state = 56},
  [83] = {.lex_state = 56},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 56},
  [86] = {.lex_state = 56},
  [87] = {.lex_state = 56},
  [88] = {.lex_state = 17},
  [89] = {.lex_state = 56},
  [90] = {.lex_state = 58},
  [91] = {.lex_state = 56},
  [92] = {.lex_state = 17},
  [93] = {.lex_state = 17},
  [94] = {.lex_state = 56},
  [95] = {.lex_state = 2},
  [96] = {.lex_state = 56},
  [97] = {.lex_state = 2},
  [98] = {.lex_state = 58},
  [99] = {.lex_state = 58},
  [100] = {.lex_state = 17},
  [101] = {.lex_state = 2},
  [102] = {.lex_state = 17},
  [103] = {.lex_state = 17},
  [104] = {.lex_state = 56},
  [105] = {.lex_state = 56},
  [106] = {.lex_state = 17},
  [107] = {.lex_state = 56},
  [108] = {.lex_state = 56},
  [109] = {.lex_state = 58},
  [110] = {.lex_state = 19},
  [111] = {.lex_state = 19},
  [112] = {.lex_state = 19},
  [113] = {.lex_state = 19},
  [114] = {.lex_state = 19},
  [115] = {.lex_state = 19},
  [116] = {.lex_state = 19},
  [117] = {.lex_state = 58},
  [118] = {.lex_state = 0},
  [119] = {.lex_state = 58},
  [120] = {.lex_state = 58},
  [121] = {.lex_state = 58},
  [122] = {.lex_state = 58},
  [123] = {.lex_state = 58},
  [124] = {.lex_state = 0},
  [125] = {.lex_state = 16},
  [126] = {.lex_state = 58},
  [127] = {.lex_state = 9},
  [128] = {.lex_state = 0},
  [129] = {.lex_state = 58},
  [130] = {.lex_state = 58},
  [131] = {.lex_state = 58},
  [132] = {.lex_state = 56},
  [133] = {.lex_state = 56},
  [134] = {.lex_state = 0},
  [135] = {.lex_state = 56},
  [136] = {.lex_state = 56},
  [137] = {.lex_state = 56},
  [138] = {.lex_state = 56},
  [139] = {.lex_state = 56},
  [140] = {.lex_state = 56},
  [141] = {.lex_state = 56},
  [142] = {.lex_state = 56},
  [143] = {.lex_state = 56},
  [144] = {.lex_state = 56},
  [145] = {.lex_state = 20},
  [146] = {.lex_state = 21},
  [147] = {.lex_state = 17},
  [148] = {.lex_state = 0},
  [149] = {.lex_state = 56},
  [150] = {.lex_state = 56},
  [151] = {.lex_state = 56},
  [152] = {.lex_state = 56},
  [153] = {.lex_state = 56},
  [154] = {.lex_state = 11},
  [155] = {.lex_state = 56},
  [156] = {.lex_state = 56},
  [157] = {.lex_state = 56},
  [158] = {.lex_state = 17},
  [159] = {.lex_state = 56},
  [160] = {.lex_state = 21},
  [161] = {.lex_state = 56},
  [162] = {.lex_state = 56},
  [163] = {.lex_state = 56},
  [164] = {.lex_state = 0},
  [165] = {.lex_state = 17},
  [166] = {.lex_state = 56},
  [167] = {.lex_state = 21},
  [168] = {.lex_state = 56},
  [169] = {.lex_state = 56},
  [170] = {.lex_state = 17},
  [171] = {.lex_state = 20},
  [172] = {.lex_state = 18},
  [173] = {.lex_state = 20},
  [174] = {.lex_state = 17},
  [175] = {.lex_state = 56},
  [176] = {.lex_state = 0},
  [177] = {.lex_state = 56},
  [178] = {.lex_state = 56},
  [179] = {.lex_state = 56},
  [180] = {.lex_state = 56},
  [181] = {.lex_state = 56},
  [182] = {.lex_state = 56},
  [183] = {.lex_state = 19},
  [184] = {.lex_state = 23},
  [185] = {.lex_state = 19},
  [186] = {.lex_state = 56},
  [187] = {.lex_state = 56},
  [188] = {.lex_state = 56},
  [189] = {.lex_state = 56},
  [190] = {.lex_state = 13},
  [191] = {.lex_state = 19},
  [192] = {.lex_state = 23},
  [193] = {.lex_state = 56},
  [194] = {.lex_state = 13},
  [195] = {.lex_state = 56},
  [196] = {.lex_state = 56},
  [197] = {.lex_state = 56},
  [198] = {.lex_state = 56},
  [199] = {.lex_state = 56},
  [200] = {.lex_state = 23},
  [201] = {.lex_state = 23},
  [202] = {.lex_state = 13},
  [203] = {.lex_state = 19},
  [204] = {.lex_state = 13},
  [205] = {.lex_state = 56},
  [206] = {.lex_state = 23},
  [207] = {.lex_state = 13},
  [208] = {.lex_state = 56},
  [209] = {.lex_state = 56},
  [210] = {.lex_state = 19},
  [211] = {.lex_state = 13},
  [212] = {.lex_state = 23},
  [213] = {.lex_state = 23},
  [214] = {.lex_state = 13},
  [215] = {.lex_state = 56},
  [216] = {.lex_state = 56},
  [217] = {.lex_state = 56},
  [218] = {.lex_state = 56},
  [219] = {.lex_state = 56},
  [220] = {.lex_state = 56},
  [221] = {.lex_state = 56},
  [222] = {.lex_state = 56},
  [223] = {.lex_state = 20},
  [224] = {.lex_state = 21},
  [225] = {.lex_state = 56},
  [226] = {.lex_state = 56},
  [227] = {.lex_state = 56},
  [228] = {.lex_state = 56},
  [229] = {.lex_state = 56},
  [230] = {.lex_state = 56},
  [231] = {.lex_state = 56},
  [232] = {.lex_state = 56},
  [233] = {.lex_state = 56},
  [234] = {.lex_state = 56},
  [235] = {.lex_state = 56},
  [236] = {.lex_state = 56},
  [237] = {.lex_state = 56},
  [238] = {.lex_state = 13},
  [239] = {.lex_state = 56},
  [240] = {.lex_state = 56},
  [241] = {.lex_state = 10},
  [242] = {.lex_state = 23},
  [243] = {.lex_state = 4},
  [244] = {.lex_state = 12},
  [245] = {.lex_state = 25},
  [246] = {.lex_state = 27},
  [247] = {.lex_state = 27},
  [248] = {.lex_state = 25},
  [249] = {.lex_state = 25},
  [250] = {.lex_state = 27},
  [251] = {.lex_state = 12},
  [252] = {.lex_state = 12},
  [253] = {.lex_state = 25},
  [254] = {.lex_state = 4},
  [255] = {.lex_state = 12},
  [256] = {.lex_state = 12},
  [257] = {.lex_state = 27},
  [258] = {.lex_state = 27},
  [259] = {.lex_state = 56},
  [260] = {.lex_state = 12},
  [261] = {.lex_state = 12},
  [262] = {.lex_state = 12},
  [263] = {.lex_state = 12},
  [264] = {.lex_state = 25},
  [265] = {.lex_state = 25},
  [266] = {.lex_state = 25},
  [267] = {.lex_state = 12},
  [268] = {.lex_state = 12},
  [269] = {.lex_state = 27},
  [270] = {.lex_state = 27},
  [271] = {.lex_state = 56},
  [272] = {.lex_state = 56},
  [273] = {.lex_state = 56},
  [274] = {.lex_state = 56},
  [275] = {.lex_state = 56},
  [276] = {.lex_state = 56},
  [277] = {.lex_state = 56},
  [278] = {.lex_state = 24},
  [279] = {.lex_state = 26},
  [280] = {.lex_state = 56},
  [281] = {.lex_state = 25},
  [282] = {.lex_state = 22},
  [283] = {.lex_state = 27},
  [284] = {.lex_state = 28},
  [285] = {.lex_state = 25},
  [286] = {.lex_state = 25},
  [287] = {.lex_state = 56},
  [288] = {.lex_state = 27},
  [289] = {.lex_state = 27},
  [290] = {.lex_state = 56},
  [291] = {.lex_state = 56},
  [292] = {.lex_state = 27},
  [293] = {.lex_state = 22},
  [294] = {.lex_state = 25},
  [295] = {.lex_state = 28},
  [296] = {.lex_state = 22},
  [297] = {.lex_state = 28},
  [298] = {.lex_state = 56},
  [299] = {.lex_state = 56},
  [300] = {.lex_state = 14},
  [301] = {.lex_state = 56},
  [302] = {.lex_state = 5},
  [303] = {.lex_state = 14},
  [304] = {.lex_state = 14},
  [305] = {.lex_state = 15},
  [306] = {.lex_state = 0},
  [307] = {.lex_state = 15},
  [308] = {.lex_state = 56},
  [309] = {.lex_state = 0},
  [310] = {.lex_state = 0},
  [311] = {.lex_state = 56},
  [312] = {.lex_state = 5},
  [313] = {.lex_state = 56},
  [314] = {.lex_state = 56},
  [315] = {.lex_state = 56},
  [316] = {.lex_state = 12},
  [317] = {.lex_state = 56},
  [318] = {.lex_state = 56},
  [319] = {.lex_state = 56},
  [320] = {.lex_state = 56},
  [321] = {.lex_state = 56},
  [322] = {.lex_state = 15},
  [323] = {.lex_state = 56},
  [324] = {.lex_state = 0},
  [325] = {.lex_state = 56},
  [326] = {.lex_state = 0},
  [327] = {.lex_state = 15},
  [328] = {.lex_state = 0},
  [329] = {.lex_state = 0},
  [330] = {.lex_state = 15},
  [331] = {.lex_state = 56},
  [332] = {.lex_state = 56},
  [333] = {.lex_state = 56},
  [334] = {.lex_state = 15},
  [335] = {.lex_state = 56},
  [336] = {.lex_state = 56},
  [337] = {.lex_state = 15},
  [338] = {.lex_state = 14},
  [339] = {.lex_state = 56},
  [340] = {.lex_state = 5},
  [341] = {.lex_state = 12},
  [342] = {.lex_state = 12},
  [343] = {.lex_state = 0},
  [344] = {.lex_state = 0},
  [345] = {.lex_state = 56},
  [346] = {.lex_state = 14},
  [347] = {.lex_state = 56},
  [348] = {.lex_state = 56},
  [349] = {.lex_state = 5},
  [350] = {.lex_state = 56},
  [351] = {.lex_state = 14},
  [352] = {.lex_state = 56},
  [353] = {.lex_state = 56},
  [354] = {.lex_state = 3},
  [355] = {.lex_state = 0},
  [356] = {.lex_state = 56},
  [357] = {.lex_state = 5},
  [358] = {.lex_state = 14},
  [359] = {.lex_state = 56},
  [360] = {.lex_state = 56},
  [361] = {.lex_state = 56},
  [362] = {.lex_state = 56},
  [363] = {.lex_state = 56},
  [364] = {.lex_state = 5},
  [365] = {.lex_state = 5},
  [366] = {.lex_state = 0},
  [367] = {.lex_state = 0},
  [368] = {.lex_state = 0},
  [369] = {.lex_state = 0},
  [370] = {.lex_state = 0},
  [371] = {.lex_state = 5},
  [372] = {.lex_state = 0},
  [373] = {.lex_state = 56},
  [374] = {.lex_state = 56},
  [375] = {.lex_state = 56},
  [376] = {.lex_state = 5},
  [377] = {.lex_state = 15},
  [378] = {.lex_state = 0},
  [379] = {.lex_state = 56},
  [380] = {.lex_state = 56},
  [381] = {.lex_state = 8},
  [382] = {.lex_state = 56},
  [383] = {.lex_state = 56},
  [384] = {.lex_state = 56},
  [385] = {.lex_state = 56},
  [386] = {.lex_state = 56},
  [387] = {.lex_state = 0},
  [388] = {.lex_state = 56},
  [389] = {.lex_state = 0},
  [390] = {.lex_state = 56},
  [391] = {.lex_state = 56},
  [392] = {.lex_state = 56},
  [393] = {.lex_state = 56},
  [394] = {.lex_state = 56},
  [395] = {.lex_state = 56},
  [396] = {.lex_state = 56},
  [397] = {.lex_state = 56},
  [398] = {.lex_state = 56},
  [399] = {.lex_state = 110},
  [400] = {.lex_state = 56},
  [401] = {.lex_state = 56},
  [402] = {.lex_state = 56},
  [403] = {.lex_state = 56},
  [404] = {.lex_state = 3},
  [405] = {.lex_state = 56},
  [406] = {.lex_state = 0},
  [407] = {.lex_state = 56},
  [408] = {.lex_state = 0},
  [409] = {.lex_state = 0},
  [410] = {.lex_state = 0},
  [411] = {.lex_state = 56},
  [412] = {.lex_state = 8},
  [413] = {.lex_state = 3},
  [414] = {.lex_state = 56},
  [415] = {.lex_state = 56},
  [416] = {.lex_state = 3},
  [417] = {.lex_state = 56},
  [418] = {.lex_state = 56},
  [419] = {.lex_state = 56},
  [420] = {.lex_state = 56},
  [421] = {.lex_state = 0},
  [422] = {.lex_state = 56},
  [423] = {.lex_state = 3},
  [424] = {.lex_state = 56},
  [425] = {.lex_state = 0},
  [426] = {.lex_state = 56},
  [427] = {.lex_state = 56},
  [428] = {.lex_state = 56},
  [429] = {.lex_state = 56},
  [430] = {.lex_state = 8},
  [431] = {.lex_state = 0},
  [432] = {.lex_state = 56},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 56},
  [435] = {.lex_state = 8},
  [436] = {.lex_state = 8},
  [437] = {.lex_state = 0},
  [438] = {.lex_state = 0},
  [439] = {.lex_state = 56},
  [440] = {.lex_state = 140},
  [441] = {.lex_state = 140},
  [442] = {.lex_state = 56},
  [443] = {.lex_state = 110},
  [444] = {.lex_state = 3},
  [445] = {.lex_state = 8},
  [446] = {.lex_state = 140},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 110},
  [449] = {.lex_state = 0},
  [450] = {.lex_state = 56},
  [451] = {.lex_state = 0},
  [452] = {.lex_state = 56},
  [453] = {.lex_state = 0},
  [454] = {.lex_state = 56},
  [455] = {.lex_state = 0},
  [456] = {.lex_state = 56},
  [457] = {.lex_state = 8},
  [458] = {.lex_state = 56},
  [459] = {.lex_state = 56},
  [460] = {.lex_state = 56},
  [461] = {.lex_state = 8},
  [462] = {.lex_state = 56},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 0},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_AT_DASH] = ACTIONS(1),
    [anon_sym_DASH_AT] = ACTIONS(1),
    [anon_sym_POUND_BANG_SLASHusr_SLASHbin_SLASHenv] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_LBRACE_LBRACE_LBRACE_LBRACE] = ACTIONS(1),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_shell] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_BSLASHn] = ACTIONS(1),
    [anon_sym_BSLASHr] = ACTIONS(1),
    [anon_sym_BSLASHt] = ACTIONS(1),
    [anon_sym_BSLASH_DQUOTE] = ACTIONS(1),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1),
    [anon_sym_x_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_x_DQUOTE] = ACTIONS(1),
    [anon_sym_x_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_x_SQUOTE] = ACTIONS(1),
    [sym_escape_variable_end] = ACTIONS(1),
    [sym_expansion_long_start] = ACTIONS(1),
    [sym_expansion_long_middle] = ACTIONS(1),
    [sym_expansion_long_end] = ACTIONS(1),
    [sym__eol] = ACTIONS(3),
    [sym_numeric_error] = ACTIONS(1),
  },
  [1] = {
    [sym_file] = STATE(455),
    [sym_alias] = STATE(49),
    [sym_assignment] = STATE(49),
    [sym_import] = STATE(49),
    [sym_mod] = STATE(49),
    [sym_recipe] = STATE(49),
    [sym__attribute_list] = STATE(240),
    [sym_setting] = STATE(49),
    [sym_comment] = STATE(49),
    [aux_sym_file_repeat1] = STATE(49),
    [aux_sym_alias_repeat1] = STATE(240),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_alias] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_mod] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(21),
    [aux_sym_comment_token1] = ACTIONS(23),
    [sym__eol] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 24,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_RPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(324), 1,
      sym_expression,
    STATE(437), 1,
      sym_function_parameters,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [76] = 23,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(59), 1,
      sym_identifier,
    ACTIONS(61), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_RPAREN,
    ACTIONS(65), 1,
      anon_sym_SLASH,
    ACTIONS(67), 1,
      anon_sym_BQUOTE,
    ACTIONS(69), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(71), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(73), 1,
      anon_sym_DQUOTE,
    ACTIONS(75), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(79), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(87), 1,
      sym_numeric_error,
    STATE(56), 1,
      sym_shell_expanded_string,
    STATE(64), 1,
      sym_value,
    STATE(6), 2,
      sym_expression,
      aux_sym_recipe_dependency_repeat1,
    STATE(57), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(51), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [150] = 24,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    ACTIONS(89), 1,
      anon_sym_RPAREN,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(324), 1,
      sym_expression,
    STATE(408), 1,
      sym_function_parameters,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [226] = 24,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    ACTIONS(91), 1,
      anon_sym_RPAREN,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(324), 1,
      sym_expression,
    STATE(409), 1,
      sym_function_parameters,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [302] = 23,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(59), 1,
      sym_identifier,
    ACTIONS(61), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_SLASH,
    ACTIONS(67), 1,
      anon_sym_BQUOTE,
    ACTIONS(69), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(71), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(73), 1,
      anon_sym_DQUOTE,
    ACTIONS(75), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(79), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(87), 1,
      sym_numeric_error,
    ACTIONS(93), 1,
      anon_sym_RPAREN,
    STATE(56), 1,
      sym_shell_expanded_string,
    STATE(64), 1,
      sym_value,
    STATE(7), 2,
      sym_expression,
      aux_sym_recipe_dependency_repeat1,
    STATE(57), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(51), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [376] = 23,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(95), 1,
      sym_identifier,
    ACTIONS(98), 1,
      anon_sym_LPAREN,
    ACTIONS(101), 1,
      anon_sym_RPAREN,
    ACTIONS(103), 1,
      anon_sym_if,
    ACTIONS(106), 1,
      anon_sym_assert,
    ACTIONS(109), 1,
      anon_sym_SLASH,
    ACTIONS(112), 1,
      anon_sym_BQUOTE,
    ACTIONS(115), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(118), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(121), 1,
      anon_sym_DQUOTE,
    ACTIONS(124), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(127), 1,
      anon_sym_SQUOTE,
    ACTIONS(130), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(133), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(136), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(142), 1,
      sym_numeric_error,
    STATE(56), 1,
      sym_shell_expanded_string,
    STATE(64), 1,
      sym_value,
    STATE(7), 2,
      sym_expression,
      aux_sym_recipe_dependency_repeat1,
    STATE(57), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(51), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [450] = 23,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(347), 1,
      sym_expression,
    STATE(403), 1,
      sym_condition,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [523] = 23,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(347), 1,
      sym_expression,
    STATE(429), 1,
      sym_condition,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [596] = 23,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(347), 1,
      sym_expression,
    STATE(392), 1,
      sym_condition,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [669] = 23,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(347), 1,
      sym_expression,
    STATE(453), 1,
      sym_condition,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [742] = 23,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(347), 1,
      sym_expression,
    STATE(451), 1,
      sym_condition,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [815] = 23,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    ACTIONS(145), 1,
      anon_sym_RPAREN,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(370), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [888] = 23,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(347), 1,
      sym_expression,
    STATE(421), 1,
      sym_condition,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [961] = 23,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    ACTIONS(147), 1,
      anon_sym_RPAREN,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(370), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1034] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(374), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1104] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(59), 1,
      sym_identifier,
    ACTIONS(61), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_BQUOTE,
    ACTIONS(69), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(71), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(73), 1,
      anon_sym_DQUOTE,
    ACTIONS(75), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(79), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(87), 1,
      sym_numeric_error,
    ACTIONS(149), 1,
      anon_sym_if,
    ACTIONS(151), 1,
      anon_sym_assert,
    ACTIONS(153), 1,
      anon_sym_SLASH,
    STATE(56), 1,
      sym_shell_expanded_string,
    STATE(354), 1,
      sym_value,
    STATE(413), 1,
      sym_expression,
    STATE(57), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(51), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1174] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(410), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1244] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(406), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1314] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(59), 1,
      sym_identifier,
    ACTIONS(61), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_BQUOTE,
    ACTIONS(69), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(71), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(73), 1,
      anon_sym_DQUOTE,
    ACTIONS(75), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(79), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(87), 1,
      sym_numeric_error,
    ACTIONS(149), 1,
      anon_sym_if,
    ACTIONS(151), 1,
      anon_sym_assert,
    ACTIONS(153), 1,
      anon_sym_SLASH,
    STATE(56), 1,
      sym_shell_expanded_string,
    STATE(354), 1,
      sym_value,
    STATE(423), 1,
      sym_expression,
    STATE(57), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(51), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1384] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(360), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1454] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(431), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1524] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(59), 1,
      sym_identifier,
    ACTIONS(61), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_SLASH,
    ACTIONS(67), 1,
      anon_sym_BQUOTE,
    ACTIONS(69), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(71), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(73), 1,
      anon_sym_DQUOTE,
    ACTIONS(75), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(79), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(87), 1,
      sym_numeric_error,
    STATE(44), 1,
      sym_expression,
    STATE(56), 1,
      sym_shell_expanded_string,
    STATE(64), 1,
      sym_value,
    STATE(57), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(51), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1594] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(405), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1664] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(433), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1734] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(438), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1804] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(370), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1874] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(401), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [1944] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(414), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2014] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(155), 1,
      sym_identifier,
    ACTIONS(157), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_if,
    ACTIONS(161), 1,
      anon_sym_assert,
    ACTIONS(163), 1,
      anon_sym_SLASH,
    ACTIONS(165), 1,
      anon_sym_BQUOTE,
    ACTIONS(167), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(169), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(171), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(177), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(179), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(181), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(183), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(185), 1,
      sym_numeric_error,
    STATE(318), 1,
      sym_shell_expanded_string,
    STATE(332), 1,
      sym_value,
    STATE(393), 1,
      sym_expression,
    STATE(331), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(335), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2084] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(439), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2154] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(44), 1,
      sym_expression,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2224] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(155), 1,
      sym_identifier,
    ACTIONS(157), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_if,
    ACTIONS(161), 1,
      anon_sym_assert,
    ACTIONS(163), 1,
      anon_sym_SLASH,
    ACTIONS(165), 1,
      anon_sym_BQUOTE,
    ACTIONS(167), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(169), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(171), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(177), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(179), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(181), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(183), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(185), 1,
      sym_numeric_error,
    STATE(318), 1,
      sym_shell_expanded_string,
    STATE(332), 1,
      sym_value,
    STATE(333), 1,
      sym_expression,
    STATE(331), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(335), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2294] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(59), 1,
      sym_identifier,
    ACTIONS(61), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_BQUOTE,
    ACTIONS(69), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(71), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(73), 1,
      anon_sym_DQUOTE,
    ACTIONS(75), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(79), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(87), 1,
      sym_numeric_error,
    ACTIONS(149), 1,
      anon_sym_if,
    ACTIONS(151), 1,
      anon_sym_assert,
    ACTIONS(153), 1,
      anon_sym_SLASH,
    STATE(56), 1,
      sym_shell_expanded_string,
    STATE(354), 1,
      sym_value,
    STATE(444), 1,
      sym_expression,
    STATE(57), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(51), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2364] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(387), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2434] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(459), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2504] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(155), 1,
      sym_identifier,
    ACTIONS(157), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_if,
    ACTIONS(161), 1,
      anon_sym_assert,
    ACTIONS(163), 1,
      anon_sym_SLASH,
    ACTIONS(165), 1,
      anon_sym_BQUOTE,
    ACTIONS(167), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(169), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(171), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(177), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(179), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(181), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(183), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(185), 1,
      sym_numeric_error,
    STATE(318), 1,
      sym_shell_expanded_string,
    STATE(332), 1,
      sym_value,
    STATE(411), 1,
      sym_expression,
    STATE(331), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(335), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2574] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(460), 1,
      sym_expression,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2644] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_SLASH,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(43), 1,
      sym_expression,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(197), 1,
      sym_value,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2714] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(155), 1,
      sym_identifier,
    ACTIONS(157), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_if,
    ACTIONS(161), 1,
      anon_sym_assert,
    ACTIONS(163), 1,
      anon_sym_SLASH,
    ACTIONS(165), 1,
      anon_sym_BQUOTE,
    ACTIONS(167), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(169), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(171), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(177), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(179), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(181), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(183), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(185), 1,
      sym_numeric_error,
    STATE(313), 1,
      sym_expression,
    STATE(318), 1,
      sym_shell_expanded_string,
    STATE(332), 1,
      sym_value,
    STATE(331), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(335), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2784] = 22,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(59), 1,
      sym_identifier,
    ACTIONS(61), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_SLASH,
    ACTIONS(67), 1,
      anon_sym_BQUOTE,
    ACTIONS(69), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(71), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(73), 1,
      anon_sym_DQUOTE,
    ACTIONS(75), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(79), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(87), 1,
      sym_numeric_error,
    STATE(43), 1,
      sym_expression,
    STATE(56), 1,
      sym_shell_expanded_string,
    STATE(64), 1,
      sym_value,
    STATE(57), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(51), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [2854] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(187), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(189), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [2885] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(191), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(193), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [2916] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(195), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(197), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [2947] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(199), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(201), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [2978] = 18,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(271), 1,
      sym_value,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [3036] = 18,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(27), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_BQUOTE,
    ACTIONS(39), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(57), 1,
      sym_numeric_error,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(276), 1,
      sym_value,
    STATE(96), 2,
      sym__backtick,
      sym__indented_backtick,
    STATE(94), 3,
      sym_function_call,
      sym_external_command,
      sym_string,
  [3094] = 13,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(203), 1,
      ts_builtin_sym_end,
    ACTIONS(205), 1,
      sym_identifier,
    ACTIONS(208), 1,
      anon_sym_alias,
    ACTIONS(211), 1,
      anon_sym_export,
    ACTIONS(214), 1,
      anon_sym_import,
    ACTIONS(217), 1,
      anon_sym_mod,
    ACTIONS(220), 1,
      anon_sym_AT,
    ACTIONS(223), 1,
      anon_sym_LBRACK,
    ACTIONS(226), 1,
      anon_sym_set,
    ACTIONS(229), 1,
      aux_sym_comment_token1,
    STATE(240), 2,
      sym__attribute_list,
      aux_sym_alias_repeat1,
    STATE(48), 8,
      sym_alias,
      sym_assignment,
      sym_import,
      sym_mod,
      sym_recipe,
      sym_setting,
      sym_comment,
      aux_sym_file_repeat1,
  [3142] = 13,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_alias,
    ACTIONS(11), 1,
      anon_sym_export,
    ACTIONS(13), 1,
      anon_sym_import,
    ACTIONS(15), 1,
      anon_sym_mod,
    ACTIONS(17), 1,
      anon_sym_AT,
    ACTIONS(19), 1,
      anon_sym_LBRACK,
    ACTIONS(21), 1,
      anon_sym_set,
    ACTIONS(23), 1,
      aux_sym_comment_token1,
    ACTIONS(232), 1,
      ts_builtin_sym_end,
    STATE(240), 2,
      sym__attribute_list,
      aux_sym_alias_repeat1,
    STATE(48), 8,
      sym_alias,
      sym_assignment,
      sym_import,
      sym_mod,
      sym_recipe,
      sym_setting,
      sym_comment,
      aux_sym_file_repeat1,
  [3190] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(234), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(236), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3217] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(238), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(240), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3244] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(242), 1,
      anon_sym_LPAREN,
    ACTIONS(238), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(240), 10,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3273] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(244), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(246), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3300] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(248), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(250), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3327] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(252), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(254), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3354] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(256), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(258), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3381] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(260), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(262), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3408] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(264), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(266), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3435] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(268), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(270), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3462] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(272), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(274), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3489] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(276), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(278), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3516] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(280), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(282), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3543] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(284), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(286), 11,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACE_RBRACE,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3570] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(292), 2,
      anon_sym_PLUS,
      anon_sym_SLASH,
    ACTIONS(288), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(290), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3598] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(294), 8,
      anon_sym_if,
      anon_sym_assert,
      anon_sym_BQUOTE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_x_DQUOTE,
      anon_sym_x_SQUOTE,
      sym_identifier,
    ACTIONS(296), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SLASH,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
      sym_numeric_error,
  [3623] = 7,
    ACTIONS(298), 1,
      ts_builtin_sym_end,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    STATE(98), 1,
      sym_shebang_line,
    STATE(137), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(300), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3654] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(306), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(155), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(308), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3685] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(310), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(141), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(312), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3716] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(314), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(133), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(316), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3747] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(318), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(132), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(320), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3778] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(322), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(140), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(324), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3809] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(326), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(149), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(328), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3840] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(330), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(161), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(332), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3871] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(334), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(144), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(336), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3902] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(338), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(168), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(340), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3933] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(342), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(143), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(344), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3964] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(346), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(159), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(348), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [3995] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(350), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(175), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(352), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [4026] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(354), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(142), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(356), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [4057] = 7,
    ACTIONS(302), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(358), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_shebang_line,
    STATE(152), 1,
      sym_recipe_body,
    STATE(90), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(360), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [4088] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(236), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4108] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(246), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4128] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(254), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4148] = 14,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(169), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(171), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(177), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(179), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(181), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(183), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(362), 1,
      anon_sym_LBRACK,
    STATE(318), 1,
      sym_shell_expanded_string,
    STATE(382), 1,
      sym_boolean,
    STATE(385), 1,
      sym_string,
    ACTIONS(364), 2,
      anon_sym_true,
      anon_sym_false,
  [4192] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(258), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4212] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(366), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4234] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(266), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4254] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(368), 1,
      anon_sym_DOLLAR,
    ACTIONS(370), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(376), 1,
      sym_expansion_long_start,
    STATE(381), 1,
      sym_expansion_short_start,
    ACTIONS(374), 2,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
    STATE(102), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_indented_normal_string_repeat2,
    ACTIONS(372), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [4285] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(278), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4304] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(378), 1,
      ts_builtin_sym_end,
    ACTIONS(382), 1,
      aux_sym_shebang_line_token1,
    STATE(109), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(380), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [4329] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(274), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4348] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(368), 1,
      anon_sym_DOLLAR,
    ACTIONS(376), 1,
      sym_expansion_long_start,
    ACTIONS(384), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(381), 1,
      sym_expansion_short_start,
    ACTIONS(386), 2,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
    STATE(88), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_indented_normal_string_repeat2,
    ACTIONS(372), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [4379] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(368), 1,
      anon_sym_DOLLAR,
    ACTIONS(376), 1,
      sym_expansion_long_start,
    ACTIONS(388), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(381), 1,
      sym_expansion_short_start,
    ACTIONS(390), 2,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
    STATE(103), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_indented_normal_string_repeat2,
    ACTIONS(372), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [4410] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(240), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4429] = 14,
    ACTIONS(169), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(171), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(177), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(179), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(181), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(183), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(394), 1,
      sym__eol,
    STATE(166), 1,
      sym__ceol,
    STATE(318), 1,
      sym_shell_expanded_string,
    STATE(350), 1,
      sym_string,
    STATE(466), 1,
      sym_comment,
  [4472] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(262), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4491] = 14,
    ACTIONS(169), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(171), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(177), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(179), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(181), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(183), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(396), 1,
      sym__eol,
    STATE(138), 1,
      sym__ceol,
    STATE(318), 1,
      sym_shell_expanded_string,
    STATE(320), 1,
      sym_string,
    STATE(466), 1,
      sym_comment,
  [4534] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(382), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(398), 1,
      ts_builtin_sym_end,
    STATE(99), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(400), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [4559] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(382), 1,
      aux_sym_shebang_line_token1,
    ACTIONS(402), 1,
      ts_builtin_sym_end,
    STATE(109), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(404), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [4584] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(368), 1,
      anon_sym_DOLLAR,
    ACTIONS(376), 1,
      sym_expansion_long_start,
    ACTIONS(406), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(381), 1,
      sym_expansion_short_start,
    ACTIONS(408), 2,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
    STATE(106), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_indented_normal_string_repeat2,
    ACTIONS(372), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [4615] = 14,
    ACTIONS(169), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(171), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(177), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(179), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(181), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(183), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(410), 1,
      sym__eol,
    STATE(150), 1,
      sym__ceol,
    STATE(315), 1,
      sym_string,
    STATE(318), 1,
      sym_shell_expanded_string,
    STATE(466), 1,
      sym_comment,
  [4658] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(412), 1,
      anon_sym_DOLLAR,
    ACTIONS(415), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(423), 1,
      sym_expansion_long_start,
    STATE(381), 1,
      sym_expansion_short_start,
    ACTIONS(420), 2,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
    STATE(102), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_indented_normal_string_repeat2,
    ACTIONS(417), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [4689] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(368), 1,
      anon_sym_DOLLAR,
    ACTIONS(376), 1,
      sym_expansion_long_start,
    ACTIONS(426), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(381), 1,
      sym_expansion_short_start,
    ACTIONS(374), 2,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
    STATE(102), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_indented_normal_string_repeat2,
    ACTIONS(372), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [4720] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(282), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4739] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(250), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4758] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(368), 1,
      anon_sym_DOLLAR,
    ACTIONS(376), 1,
      sym_expansion_long_start,
    ACTIONS(428), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(381), 1,
      sym_expansion_short_start,
    ACTIONS(374), 2,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
    STATE(102), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_indented_normal_string_repeat2,
    ACTIONS(372), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [4789] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(270), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4808] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(286), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
      sym_identifier,
  [4827] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(430), 1,
      ts_builtin_sym_end,
    ACTIONS(434), 1,
      aux_sym_shebang_line_token1,
    STATE(109), 2,
      sym_recipe_line,
      aux_sym_recipe_body_repeat1,
    ACTIONS(432), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [4852] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(437), 1,
      anon_sym_DOLLAR,
    ACTIONS(440), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      aux_sym__shell_expanded_normal_string_token2,
    ACTIONS(448), 1,
      sym_expansion_long_start,
    STATE(457), 1,
      sym_expansion_short_start,
    STATE(110), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_normal_string_repeat2,
    ACTIONS(442), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [4882] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(384), 1,
      anon_sym_DQUOTE,
    ACTIONS(451), 1,
      anon_sym_DOLLAR,
    ACTIONS(455), 1,
      aux_sym__shell_expanded_normal_string_token2,
    ACTIONS(457), 1,
      sym_expansion_long_start,
    STATE(457), 1,
      sym_expansion_short_start,
    STATE(114), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_normal_string_repeat2,
    ACTIONS(453), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [4912] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(406), 1,
      anon_sym_DQUOTE,
    ACTIONS(451), 1,
      anon_sym_DOLLAR,
    ACTIONS(457), 1,
      sym_expansion_long_start,
    ACTIONS(459), 1,
      aux_sym__shell_expanded_normal_string_token2,
    STATE(457), 1,
      sym_expansion_short_start,
    STATE(113), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_normal_string_repeat2,
    ACTIONS(453), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [4942] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(428), 1,
      anon_sym_DQUOTE,
    ACTIONS(451), 1,
      anon_sym_DOLLAR,
    ACTIONS(457), 1,
      sym_expansion_long_start,
    ACTIONS(461), 1,
      aux_sym__shell_expanded_normal_string_token2,
    STATE(457), 1,
      sym_expansion_short_start,
    STATE(110), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_normal_string_repeat2,
    ACTIONS(453), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [4972] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(451), 1,
      anon_sym_DOLLAR,
    ACTIONS(457), 1,
      sym_expansion_long_start,
    ACTIONS(461), 1,
      aux_sym__shell_expanded_normal_string_token2,
    STATE(457), 1,
      sym_expansion_short_start,
    STATE(110), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_normal_string_repeat2,
    ACTIONS(453), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [5002] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(426), 1,
      anon_sym_DQUOTE,
    ACTIONS(451), 1,
      anon_sym_DOLLAR,
    ACTIONS(457), 1,
      sym_expansion_long_start,
    ACTIONS(461), 1,
      aux_sym__shell_expanded_normal_string_token2,
    STATE(457), 1,
      sym_expansion_short_start,
    STATE(110), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_normal_string_repeat2,
    ACTIONS(453), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [5032] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(388), 1,
      anon_sym_DQUOTE,
    ACTIONS(451), 1,
      anon_sym_DOLLAR,
    ACTIONS(457), 1,
      sym_expansion_long_start,
    ACTIONS(463), 1,
      aux_sym__shell_expanded_normal_string_token2,
    STATE(457), 1,
      sym_expansion_short_start,
    STATE(115), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_normal_string_repeat2,
    ACTIONS(453), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [5062] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(465), 2,
      ts_builtin_sym_end,
      aux_sym_shebang_line_token1,
    ACTIONS(467), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [5081] = 12,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(469), 1,
      anon_sym_RBRACK,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(366), 1,
      sym_string,
  [5118] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(471), 2,
      ts_builtin_sym_end,
      aux_sym_shebang_line_token1,
    ACTIONS(473), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [5137] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(475), 2,
      ts_builtin_sym_end,
      aux_sym_shebang_line_token1,
    ACTIONS(477), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [5156] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(479), 2,
      ts_builtin_sym_end,
      aux_sym_shebang_line_token1,
    ACTIONS(481), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [5175] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(483), 2,
      ts_builtin_sym_end,
      aux_sym_shebang_line_token1,
    ACTIONS(485), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [5194] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(487), 2,
      ts_builtin_sym_end,
      aux_sym_shebang_line_token1,
    ACTIONS(489), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [5213] = 12,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(491), 1,
      anon_sym_RBRACK,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(366), 1,
      sym_string,
  [5250] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(495), 1,
      sym_shell_variable_name,
    ACTIONS(493), 10,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
      sym_expansion_long_start,
  [5269] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(497), 2,
      ts_builtin_sym_end,
      aux_sym_shebang_line_token1,
    ACTIONS(499), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [5288] = 8,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(505), 1,
      anon_sym_POUND_BANG_SLASHusr_SLASHbin_SLASHenv,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(268), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(501), 2,
      anon_sym_AT,
      anon_sym_DASH,
    ACTIONS(503), 2,
      anon_sym_AT_DASH,
      anon_sym_DASH_AT,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [5317] = 12,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(169), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(171), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(177), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(179), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(181), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(183), 1,
      anon_sym_x_SQUOTE,
    ACTIONS(511), 1,
      anon_sym_QMARK,
    STATE(317), 1,
      sym_string,
    STATE(318), 1,
      sym_shell_expanded_string,
  [5354] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(513), 2,
      ts_builtin_sym_end,
      aux_sym_shebang_line_token1,
    ACTIONS(515), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [5373] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(513), 2,
      ts_builtin_sym_end,
      aux_sym_shebang_line_token1,
    ACTIONS(515), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [5392] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(517), 2,
      ts_builtin_sym_end,
      aux_sym_shebang_line_token1,
    ACTIONS(519), 9,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_set,
      sym_identifier,
      aux_sym_comment_token1,
  [5411] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(354), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(356), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5429] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(521), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(523), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5447] = 11,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(366), 1,
      sym_string,
  [5481] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(525), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(527), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5499] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(497), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(499), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5517] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(326), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(328), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5535] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(529), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(531), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5553] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(533), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(535), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5571] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(537), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(539), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5589] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(322), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(324), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5607] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(330), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(332), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5625] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(318), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(320), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5643] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(358), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(360), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5661] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(545), 1,
      sym_expansion_long_end,
    ACTIONS(543), 2,
      aux_sym__shell_expanded_normal_string_token1,
      sym_escape_variable_end,
    STATE(173), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_normal_string_repeat1,
    ACTIONS(541), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [5683] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(551), 1,
      sym_expansion_long_end,
    ACTIONS(549), 2,
      aux_sym__shell_expanded_indented_normal_string_token1,
      sym_escape_variable_end,
    STATE(167), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_indented_normal_string_repeat1,
    ACTIONS(547), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [5705] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(553), 10,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
      sym_expansion_long_start,
  [5721] = 11,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(309), 1,
      sym_string,
  [5755] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(314), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(316), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5773] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(555), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(557), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5791] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(559), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(561), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5809] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(310), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(312), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5827] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(563), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(565), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5845] = 6,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(268), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
    ACTIONS(501), 4,
      anon_sym_AT,
      anon_sym_AT_DASH,
      anon_sym_DASH_AT,
      anon_sym_DASH,
  [5869] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(342), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(344), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5887] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(567), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(569), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5905] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(571), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(573), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5923] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(575), 10,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
      sym_expansion_long_start,
  [5939] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(298), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(300), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5957] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(579), 1,
      sym_expansion_long_end,
    ACTIONS(577), 2,
      aux_sym__shell_expanded_indented_normal_string_token1,
      sym_escape_variable_end,
    STATE(146), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_indented_normal_string_repeat1,
    ACTIONS(547), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [5979] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(581), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(583), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [5997] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(585), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(587), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [6015] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(589), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(591), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [6033] = 11,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(41), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(47), 1,
      anon_sym_SQUOTE,
    ACTIONS(49), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(55), 1,
      anon_sym_x_SQUOTE,
    STATE(85), 1,
      sym_shell_expanded_string,
    STATE(389), 1,
      sym_string,
  [6067] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(593), 10,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
      sym_expansion_long_start,
  [6083] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(595), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(597), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [6101] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(605), 1,
      sym_expansion_long_end,
    ACTIONS(602), 2,
      aux_sym__shell_expanded_indented_normal_string_token1,
      sym_escape_variable_end,
    STATE(167), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_indented_normal_string_repeat1,
    ACTIONS(599), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [6123] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(346), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(348), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [6141] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(607), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(609), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [6159] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(415), 10,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
      sym_expansion_long_start,
  [6175] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(613), 1,
      sym_expansion_long_end,
    ACTIONS(611), 2,
      aux_sym__shell_expanded_normal_string_token1,
      sym_escape_variable_end,
    STATE(145), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_normal_string_repeat1,
    ACTIONS(541), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [6197] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(617), 1,
      sym_shell_variable_name,
    ACTIONS(615), 9,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_normal_string_token2,
      sym_expansion_long_start,
  [6215] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(625), 1,
      sym_expansion_long_end,
    ACTIONS(622), 2,
      aux_sym__shell_expanded_normal_string_token1,
      sym_escape_variable_end,
    STATE(173), 2,
      sym_escape_sequence,
      aux_sym__shell_expanded_normal_string_repeat1,
    ACTIONS(619), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [6237] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(627), 10,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_indented_normal_string_token2,
      sym_escape_variable_end,
      sym_expansion_long_start,
  [6253] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(334), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(336), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [6271] = 11,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(169), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(171), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(177), 1,
      anon_sym_x_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(179), 1,
      anon_sym_x_DQUOTE,
    ACTIONS(181), 1,
      anon_sym_x_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(183), 1,
      anon_sym_x_SQUOTE,
    STATE(318), 1,
      sym_shell_expanded_string,
    STATE(352), 1,
      sym_string,
  [6305] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(629), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(631), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [6323] = 10,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(633), 1,
      sym_identifier,
    ACTIONS(635), 1,
      anon_sym_COLON_EQ,
    ACTIONS(637), 1,
      anon_sym_COLON,
    ACTIONS(639), 1,
      anon_sym_DOLLAR,
    STATE(235), 1,
      aux_sym_recipe_parameters_repeat1,
    STATE(274), 1,
      sym_recipe_parameter,
    STATE(386), 1,
      sym_variadic_parameter,
    STATE(394), 1,
      sym_recipe_parameters,
    ACTIONS(641), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
  [6355] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(643), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(645), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [6373] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(647), 4,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_LBRACK,
      aux_sym_comment_token1,
    ACTIONS(649), 6,
      anon_sym_alias,
      anon_sym_export,
      anon_sym_import,
      anon_sym_mod,
      anon_sym_set,
      sym_identifier,
  [6391] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(653), 1,
      anon_sym_AMP_AMP,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(657), 1,
      sym__eol,
    STATE(76), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [6420] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(661), 1,
      sym__eol,
    STATE(74), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [6449] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(663), 9,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_normal_string_token2,
      sym_expansion_long_start,
  [6464] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(665), 1,
      anon_sym_DQUOTE,
    ACTIONS(667), 1,
      aux_sym__normal_string_token1,
    STATE(184), 2,
      sym_escape_sequence,
      aux_sym__normal_string_repeat1,
    ACTIONS(670), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [6485] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(440), 9,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_normal_string_token2,
      sym_expansion_long_start,
  [6500] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(673), 1,
      anon_sym_AMP_AMP,
    ACTIONS(675), 1,
      sym__eol,
    STATE(70), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [6529] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(677), 1,
      anon_sym_AMP_AMP,
    ACTIONS(679), 1,
      sym__eol,
    STATE(66), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [6558] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(681), 1,
      anon_sym_AMP_AMP,
    ACTIONS(683), 1,
      sym__eol,
    STATE(77), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(187), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [6587] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(685), 1,
      anon_sym_AMP_AMP,
    ACTIONS(687), 1,
      sym__eol,
    STATE(67), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(181), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [6616] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(689), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(691), 1,
      aux_sym__indented_normal_string_token1,
    STATE(204), 2,
      sym_escape_sequence,
      aux_sym__indented_normal_string_repeat1,
    ACTIONS(693), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [6637] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(695), 9,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_normal_string_token2,
      sym_expansion_long_start,
  [6652] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(689), 1,
      anon_sym_DQUOTE,
    ACTIONS(697), 1,
      aux_sym__normal_string_token1,
    STATE(200), 2,
      sym_escape_sequence,
      aux_sym__normal_string_repeat1,
    ACTIONS(699), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [6673] = 9,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(633), 1,
      sym_identifier,
    ACTIONS(639), 1,
      anon_sym_DOLLAR,
    ACTIONS(701), 1,
      anon_sym_COLON,
    STATE(235), 1,
      aux_sym_recipe_parameters_repeat1,
    STATE(274), 1,
      sym_recipe_parameter,
    STATE(386), 1,
      sym_variadic_parameter,
    STATE(450), 1,
      sym_recipe_parameters,
    ACTIONS(641), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
  [6702] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(703), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(705), 1,
      aux_sym__indented_normal_string_token1,
    STATE(194), 2,
      sym_escape_sequence,
      aux_sym__indented_normal_string_repeat1,
    ACTIONS(708), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [6723] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(661), 1,
      sym__eol,
    STATE(74), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(198), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [6752] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(681), 1,
      anon_sym_AMP_AMP,
    ACTIONS(683), 1,
      sym__eol,
    STATE(77), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [6781] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(711), 2,
      anon_sym_PLUS,
      anon_sym_SLASH,
    ACTIONS(290), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_TILDE,
  [6798] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(713), 1,
      anon_sym_AMP_AMP,
    ACTIONS(715), 1,
      sym__eol,
    STATE(80), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [6827] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(719), 1,
      sym__eol,
    STATE(78), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(182), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [6856] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(721), 1,
      anon_sym_DQUOTE,
    ACTIONS(723), 1,
      aux_sym__normal_string_token1,
    STATE(184), 2,
      sym_escape_sequence,
      aux_sym__normal_string_repeat1,
    ACTIONS(699), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [6877] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(723), 1,
      aux_sym__normal_string_token1,
    ACTIONS(725), 1,
      anon_sym_DQUOTE,
    STATE(184), 2,
      sym_escape_sequence,
      aux_sym__normal_string_repeat1,
    ACTIONS(699), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [6898] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(725), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(727), 1,
      aux_sym__indented_normal_string_token1,
    STATE(194), 2,
      sym_escape_sequence,
      aux_sym__indented_normal_string_repeat1,
    ACTIONS(693), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [6919] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(729), 9,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_normal_string_token2,
      sym_expansion_long_start,
  [6934] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(721), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(727), 1,
      aux_sym__indented_normal_string_token1,
    STATE(194), 2,
      sym_escape_sequence,
      aux_sym__indented_normal_string_repeat1,
    ACTIONS(693), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [6955] = 9,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(633), 1,
      sym_identifier,
    ACTIONS(639), 1,
      anon_sym_DOLLAR,
    ACTIONS(731), 1,
      anon_sym_COLON,
    STATE(235), 1,
      aux_sym_recipe_parameters_repeat1,
    STATE(274), 1,
      sym_recipe_parameter,
    STATE(386), 1,
      sym_variadic_parameter,
    STATE(390), 1,
      sym_recipe_parameters,
    ACTIONS(641), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
  [6984] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(733), 1,
      anon_sym_DQUOTE,
    ACTIONS(735), 1,
      aux_sym__normal_string_token1,
    STATE(201), 2,
      sym_escape_sequence,
      aux_sym__normal_string_repeat1,
    ACTIONS(699), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [7005] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(733), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(737), 1,
      aux_sym__indented_normal_string_token1,
    STATE(202), 2,
      sym_escape_sequence,
      aux_sym__indented_normal_string_repeat1,
    ACTIONS(693), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [7026] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(653), 1,
      anon_sym_AMP_AMP,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(657), 1,
      sym__eol,
    STATE(76), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(186), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7055] = 9,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(739), 1,
      anon_sym_AMP_AMP,
    ACTIONS(741), 1,
      sym__eol,
    STATE(75), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(196), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7084] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(627), 9,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_normal_string_token2,
      sym_expansion_long_start,
  [7099] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(743), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(745), 1,
      aux_sym__indented_normal_string_token1,
    STATE(214), 2,
      sym_escape_sequence,
      aux_sym__indented_normal_string_repeat1,
    ACTIONS(693), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [7120] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(743), 1,
      anon_sym_DQUOTE,
    ACTIONS(747), 1,
      aux_sym__normal_string_token1,
    STATE(213), 2,
      sym_escape_sequence,
      aux_sym__normal_string_repeat1,
    ACTIONS(699), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [7141] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(723), 1,
      aux_sym__normal_string_token1,
    ACTIONS(749), 1,
      anon_sym_DQUOTE,
    STATE(184), 2,
      sym_escape_sequence,
      aux_sym__normal_string_repeat1,
    ACTIONS(699), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [7162] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(727), 1,
      aux_sym__indented_normal_string_token1,
    ACTIONS(749), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(194), 2,
      sym_escape_sequence,
      aux_sym__indented_normal_string_repeat1,
    ACTIONS(693), 5,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [7183] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(715), 1,
      sym__eol,
    STATE(80), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(233), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7209] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(679), 1,
      sym__eol,
    STATE(66), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7235] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(679), 1,
      sym__eol,
    STATE(66), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(225), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7261] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(675), 1,
      sym__eol,
    STATE(70), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(226), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7287] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(675), 1,
      sym__eol,
    STATE(70), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7313] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(751), 1,
      sym__eol,
    STATE(71), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7339] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(753), 1,
      sym__eol,
    STATE(69), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7365] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(755), 1,
      sym__eol,
    STATE(79), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(230), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7391] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(757), 1,
      sym_expansion_long_end,
    ACTIONS(627), 7,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_normal_string_token1,
      sym_escape_variable_end,
  [7407] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(757), 1,
      sym_expansion_long_end,
    ACTIONS(627), 7,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      aux_sym__shell_expanded_indented_normal_string_token1,
      sym_escape_variable_end,
  [7423] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(759), 1,
      sym__eol,
    STATE(72), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7449] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(755), 1,
      sym__eol,
    STATE(79), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7475] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(759), 1,
      sym__eol,
    STATE(72), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(221), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7501] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(661), 1,
      sym__eol,
    STATE(74), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(229), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7527] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(715), 1,
      sym__eol,
    STATE(80), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7553] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(761), 1,
      sym__eol,
    STATE(73), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7579] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(657), 1,
      sym__eol,
    STATE(76), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(219), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7605] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      sym__eol,
    STATE(77), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(216), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7631] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(763), 1,
      sym__eol,
    STATE(68), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7657] = 8,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(651), 1,
      sym_identifier,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    ACTIONS(763), 1,
      sym__eol,
    STATE(68), 1,
      sym__ceol,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(464), 1,
      sym_comment,
    STATE(220), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
  [7683] = 7,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(633), 1,
      sym_identifier,
    ACTIONS(639), 1,
      anon_sym_DOLLAR,
    STATE(259), 1,
      aux_sym_recipe_parameters_repeat1,
    STATE(275), 1,
      sym_recipe_parameter,
    STATE(422), 1,
      sym_variadic_parameter,
    ACTIONS(641), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
  [7706] = 5,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(767), 1,
      anon_sym_AT,
    ACTIONS(769), 1,
      anon_sym_LBRACK,
    STATE(236), 2,
      sym__attribute_list,
      aux_sym_alias_repeat1,
    ACTIONS(765), 3,
      anon_sym_alias,
      anon_sym_mod,
      sym_identifier,
  [7725] = 6,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(772), 1,
      anon_sym_COLON_EQ,
    ACTIONS(774), 1,
      sym__eol,
    STATE(163), 1,
      sym__ceol,
    STATE(466), 1,
      sym_comment,
    STATE(308), 3,
      sym__setting_boolean,
      sym__setting_string,
      sym__setting_list,
  [7746] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(627), 7,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym__indented_normal_string_token1,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [7759] = 5,
    ACTIONS(776), 1,
      sym_identifier,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    STATE(298), 1,
      sym__recipe_dependency,
    STATE(239), 2,
      sym_recipe_dependency,
      aux_sym_recipe_repeat1,
    ACTIONS(779), 3,
      anon_sym_AMP_AMP,
      aux_sym_comment_token1,
      sym__eol,
  [7778] = 7,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(19), 1,
      anon_sym_LBRACK,
    ACTIONS(784), 1,
      sym_identifier,
    ACTIONS(786), 1,
      anon_sym_alias,
    ACTIONS(788), 1,
      anon_sym_mod,
    ACTIONS(790), 1,
      anon_sym_AT,
    STATE(236), 2,
      sym__attribute_list,
      aux_sym_alias_repeat1,
  [7801] = 6,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(792), 1,
      anon_sym_POUND_BANG_SLASHusr_SLASHbin_SLASHenv,
    STATE(244), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [7822] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(627), 7,
      anon_sym_DQUOTE,
      aux_sym__normal_string_token1,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_BSLASH,
  [7835] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(796), 1,
      anon_sym_EQ,
    ACTIONS(794), 5,
      anon_sym_COLON,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym_identifier,
  [7849] = 5,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(798), 1,
      sym__eol,
    STATE(267), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [7867] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(800), 1,
      anon_sym_DOLLAR,
    ACTIONS(802), 1,
      aux_sym__shell_expanded_raw_string_token2,
    ACTIONS(804), 1,
      sym_expansion_long_start,
    STATE(264), 1,
      aux_sym__shell_expanded_raw_string_repeat2,
    STATE(430), 1,
      sym_expansion_short_start,
  [7889] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(370), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(806), 1,
      anon_sym_DOLLAR,
    ACTIONS(808), 1,
      aux_sym__shell_expanded_indented_raw_string_token1,
    ACTIONS(810), 1,
      sym_expansion_long_start,
    STATE(269), 1,
      aux_sym__shell_expanded_indented_raw_string_repeat2,
    STATE(436), 1,
      sym_expansion_short_start,
  [7911] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(388), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(806), 1,
      anon_sym_DOLLAR,
    ACTIONS(810), 1,
      sym_expansion_long_start,
    ACTIONS(812), 1,
      aux_sym__shell_expanded_indented_raw_string_token1,
    STATE(258), 1,
      aux_sym__shell_expanded_indented_raw_string_repeat2,
    STATE(436), 1,
      sym_expansion_short_start,
  [7933] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(370), 1,
      anon_sym_SQUOTE,
    ACTIONS(800), 1,
      anon_sym_DOLLAR,
    ACTIONS(804), 1,
      sym_expansion_long_start,
    ACTIONS(814), 1,
      aux_sym__shell_expanded_raw_string_token2,
    STATE(266), 1,
      aux_sym__shell_expanded_raw_string_repeat2,
    STATE(430), 1,
      sym_expansion_short_start,
  [7955] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(406), 1,
      anon_sym_SQUOTE,
    ACTIONS(800), 1,
      anon_sym_DOLLAR,
    ACTIONS(804), 1,
      sym_expansion_long_start,
    ACTIONS(816), 1,
      aux_sym__shell_expanded_raw_string_token2,
    STATE(253), 1,
      aux_sym__shell_expanded_raw_string_repeat2,
    STATE(430), 1,
      sym_expansion_short_start,
  [7977] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(428), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(806), 1,
      anon_sym_DOLLAR,
    ACTIONS(808), 1,
      aux_sym__shell_expanded_indented_raw_string_token1,
    ACTIONS(810), 1,
      sym_expansion_long_start,
    STATE(269), 1,
      aux_sym__shell_expanded_indented_raw_string_repeat2,
    STATE(436), 1,
      sym_expansion_short_start,
  [7999] = 5,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(818), 1,
      sym__eol,
    STATE(267), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [8017] = 5,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(260), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [8035] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(428), 1,
      anon_sym_SQUOTE,
    ACTIONS(800), 1,
      anon_sym_DOLLAR,
    ACTIONS(804), 1,
      sym_expansion_long_start,
    ACTIONS(814), 1,
      aux_sym__shell_expanded_raw_string_token2,
    STATE(266), 1,
      aux_sym__shell_expanded_raw_string_repeat2,
    STATE(430), 1,
      sym_expansion_short_start,
  [8057] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(822), 1,
      anon_sym_EQ,
    ACTIONS(820), 5,
      anon_sym_COLON,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym_identifier,
  [8071] = 5,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(824), 1,
      sym__eol,
    STATE(251), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [8089] = 5,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(826), 1,
      sym__eol,
    STATE(267), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [8107] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(406), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(806), 1,
      anon_sym_DOLLAR,
    ACTIONS(810), 1,
      sym_expansion_long_start,
    ACTIONS(828), 1,
      aux_sym__shell_expanded_indented_raw_string_token1,
    STATE(250), 1,
      aux_sym__shell_expanded_indented_raw_string_repeat2,
    STATE(436), 1,
      sym_expansion_short_start,
  [8129] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(426), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(806), 1,
      anon_sym_DOLLAR,
    ACTIONS(808), 1,
      aux_sym__shell_expanded_indented_raw_string_token1,
    ACTIONS(810), 1,
      sym_expansion_long_start,
    STATE(269), 1,
      aux_sym__shell_expanded_indented_raw_string_repeat2,
    STATE(436), 1,
      sym_expansion_short_start,
  [8151] = 5,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(830), 1,
      sym_identifier,
    ACTIONS(833), 1,
      anon_sym_DOLLAR,
    ACTIONS(836), 2,
      anon_sym_PLUS,
      anon_sym_STAR,
    STATE(259), 2,
      sym_recipe_parameter,
      aux_sym_recipe_parameters_repeat1,
  [8169] = 5,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(838), 1,
      sym__eol,
    STATE(267), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [8187] = 5,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(840), 1,
      sym__eol,
    STATE(267), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [8205] = 5,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(842), 1,
      sym__eol,
    STATE(256), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [8223] = 5,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(844), 1,
      sym__eol,
    STATE(261), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [8241] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(426), 1,
      anon_sym_SQUOTE,
    ACTIONS(800), 1,
      anon_sym_DOLLAR,
    ACTIONS(804), 1,
      sym_expansion_long_start,
    ACTIONS(814), 1,
      aux_sym__shell_expanded_raw_string_token2,
    STATE(266), 1,
      aux_sym__shell_expanded_raw_string_repeat2,
    STATE(430), 1,
      sym_expansion_short_start,
  [8263] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(384), 1,
      anon_sym_SQUOTE,
    ACTIONS(800), 1,
      anon_sym_DOLLAR,
    ACTIONS(804), 1,
      sym_expansion_long_start,
    ACTIONS(846), 1,
      aux_sym__shell_expanded_raw_string_token2,
    STATE(248), 1,
      aux_sym__shell_expanded_raw_string_repeat2,
    STATE(430), 1,
      sym_expansion_short_start,
  [8285] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(848), 1,
      anon_sym_DOLLAR,
    ACTIONS(851), 1,
      anon_sym_SQUOTE,
    ACTIONS(853), 1,
      aux_sym__shell_expanded_raw_string_token2,
    ACTIONS(856), 1,
      sym_expansion_long_start,
    STATE(266), 1,
      aux_sym__shell_expanded_raw_string_repeat2,
    STATE(430), 1,
      sym_expansion_short_start,
  [8307] = 5,
    ACTIONS(862), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(865), 1,
      sym__eol,
    STATE(267), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(859), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [8325] = 5,
    ACTIONS(509), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(867), 1,
      sym__eol,
    STATE(267), 1,
      aux_sym_shebang_line_repeat2,
    ACTIONS(507), 2,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
    STATE(342), 2,
      sym__recipe_line_choice,
      sym_interpolation,
  [8343] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(869), 1,
      anon_sym_DOLLAR,
    ACTIONS(872), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(874), 1,
      aux_sym__shell_expanded_indented_raw_string_token1,
    ACTIONS(877), 1,
      sym_expansion_long_start,
    STATE(269), 1,
      aux_sym__shell_expanded_indented_raw_string_repeat2,
    STATE(436), 1,
      sym_expansion_short_start,
  [8365] = 7,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(384), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(806), 1,
      anon_sym_DOLLAR,
    ACTIONS(810), 1,
      sym_expansion_long_start,
    ACTIONS(880), 1,
      aux_sym__shell_expanded_indented_raw_string_token1,
    STATE(246), 1,
      aux_sym__shell_expanded_indented_raw_string_repeat2,
    STATE(436), 1,
      sym_expansion_short_start,
  [8387] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(882), 5,
      anon_sym_COLON,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym_identifier,
  [8398] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(886), 2,
      anon_sym_AT,
      anon_sym_LBRACK,
    ACTIONS(884), 3,
      anon_sym_alias,
      anon_sym_mod,
      sym_identifier,
  [8411] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(497), 2,
      anon_sym_AT,
      anon_sym_LBRACK,
    ACTIONS(499), 3,
      anon_sym_alias,
      anon_sym_mod,
      sym_identifier,
  [8424] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(890), 1,
      anon_sym_COLON,
    ACTIONS(888), 4,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym_identifier,
  [8437] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(892), 1,
      anon_sym_COLON,
    ACTIONS(888), 4,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym_identifier,
  [8450] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(894), 5,
      anon_sym_COLON,
      anon_sym_DOLLAR,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym_identifier,
  [8461] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(898), 2,
      anon_sym_AT,
      anon_sym_LBRACK,
    ACTIONS(896), 3,
      anon_sym_alias,
      anon_sym_mod,
      sym_identifier,
  [8474] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(617), 1,
      sym_shell_variable_name,
    ACTIONS(900), 4,
      anon_sym_DOLLAR,
      anon_sym_SQUOTE,
      aux_sym__shell_expanded_raw_string_token2,
      sym_expansion_long_start,
  [8487] = 3,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(495), 1,
      sym_shell_variable_name,
    ACTIONS(902), 4,
      anon_sym_DOLLAR,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      aux_sym__shell_expanded_indented_raw_string_token1,
      sym_expansion_long_start,
  [8500] = 1,
    ACTIONS(296), 5,
      anon_sym_AMP_AMP,
      anon_sym_LPAREN,
      sym_identifier,
      aux_sym_comment_token1,
      sym__eol,
  [8508] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(904), 4,
      anon_sym_DOLLAR,
      anon_sym_SQUOTE,
      aux_sym__shell_expanded_raw_string_token2,
      sym_expansion_long_start,
  [8518] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(908), 1,
      sym_expansion_long_end,
    STATE(296), 1,
      aux_sym__shell_expanded_indented_raw_string_repeat1,
    ACTIONS(906), 2,
      aux_sym__shell_expanded_indented_normal_string_token1,
      sym_escape_variable_end,
  [8532] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(910), 4,
      anon_sym_DOLLAR,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      aux_sym__shell_expanded_indented_raw_string_token1,
      sym_expansion_long_start,
  [8542] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(914), 1,
      sym_expansion_long_end,
    STATE(297), 1,
      aux_sym__shell_expanded_raw_string_repeat1,
    ACTIONS(912), 2,
      aux_sym__shell_expanded_raw_string_token1,
      sym_escape_variable_end,
  [8556] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(851), 4,
      anon_sym_DOLLAR,
      anon_sym_SQUOTE,
      aux_sym__shell_expanded_raw_string_token2,
      sym_expansion_long_start,
  [8566] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(916), 4,
      anon_sym_DOLLAR,
      anon_sym_SQUOTE,
      aux_sym__shell_expanded_raw_string_token2,
      sym_expansion_long_start,
  [8576] = 1,
    ACTIONS(918), 5,
      anon_sym_AMP_AMP,
      anon_sym_LPAREN,
      sym_identifier,
      aux_sym_comment_token1,
      sym__eol,
  [8584] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(872), 4,
      anon_sym_DOLLAR,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      aux_sym__shell_expanded_indented_raw_string_token1,
      sym_expansion_long_start,
  [8594] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(920), 4,
      anon_sym_DOLLAR,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      aux_sym__shell_expanded_indented_raw_string_token1,
      sym_expansion_long_start,
  [8604] = 2,
    ACTIONS(922), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [8614] = 1,
    ACTIONS(924), 5,
      anon_sym_AMP_AMP,
      anon_sym_LPAREN,
      sym_identifier,
      aux_sym_comment_token1,
      sym__eol,
  [8622] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(926), 4,
      anon_sym_DOLLAR,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      aux_sym__shell_expanded_indented_raw_string_token1,
      sym_expansion_long_start,
  [8632] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(931), 1,
      sym_expansion_long_end,
    STATE(293), 1,
      aux_sym__shell_expanded_indented_raw_string_repeat1,
    ACTIONS(928), 2,
      aux_sym__shell_expanded_indented_normal_string_token1,
      sym_escape_variable_end,
  [8646] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(933), 4,
      anon_sym_DOLLAR,
      anon_sym_SQUOTE,
      aux_sym__shell_expanded_raw_string_token2,
      sym_expansion_long_start,
  [8656] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(938), 1,
      sym_expansion_long_end,
    STATE(295), 1,
      aux_sym__shell_expanded_raw_string_repeat1,
    ACTIONS(935), 2,
      aux_sym__shell_expanded_raw_string_token1,
      sym_escape_variable_end,
  [8670] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(942), 1,
      sym_expansion_long_end,
    STATE(293), 1,
      aux_sym__shell_expanded_indented_raw_string_repeat1,
    ACTIONS(940), 2,
      aux_sym__shell_expanded_indented_normal_string_token1,
      sym_escape_variable_end,
  [8684] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(946), 1,
      sym_expansion_long_end,
    STATE(295), 1,
      aux_sym__shell_expanded_raw_string_repeat1,
    ACTIONS(944), 2,
      aux_sym__shell_expanded_raw_string_token1,
      sym_escape_variable_end,
  [8698] = 1,
    ACTIONS(948), 5,
      anon_sym_AMP_AMP,
      anon_sym_LPAREN,
      sym_identifier,
      aux_sym_comment_token1,
      sym__eol,
  [8706] = 1,
    ACTIONS(250), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [8713] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(725), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(950), 1,
      aux_sym__indented_raw_string_token1,
    STATE(303), 1,
      aux_sym__indented_raw_string_repeat1,
  [8726] = 1,
    ACTIONS(236), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [8733] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(952), 1,
      aux_sym_shebang_line_token2,
    ACTIONS(954), 1,
      sym_shebang_shell,
    STATE(349), 1,
      aux_sym_shebang_line_repeat1,
  [8746] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(956), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(958), 1,
      aux_sym__indented_raw_string_token1,
    STATE(303), 1,
      aux_sym__indented_raw_string_repeat1,
  [8759] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(689), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(961), 1,
      aux_sym__indented_raw_string_token1,
    STATE(358), 1,
      aux_sym__indented_raw_string_repeat1,
  [8772] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(963), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(965), 1,
      aux_sym__indented_backtick_token1,
    STATE(322), 1,
      aux_sym__indented_backtick_repeat1,
  [8785] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(970), 1,
      anon_sym_RBRACK,
    STATE(306), 1,
      aux_sym__setting_list_repeat1,
  [8798] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(965), 1,
      aux_sym__indented_backtick_token1,
    ACTIONS(972), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(305), 1,
      aux_sym__indented_backtick_repeat1,
  [8811] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(974), 1,
      sym__eol,
    STATE(151), 1,
      sym__ceol,
    STATE(466), 1,
      sym_comment,
  [8824] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(976), 1,
      anon_sym_COMMA,
    ACTIONS(978), 1,
      anon_sym_RBRACK,
    STATE(343), 1,
      aux_sym__setting_list_repeat1,
  [8837] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(980), 1,
      anon_sym_COMMA,
    ACTIONS(983), 1,
      anon_sym_RPAREN,
    STATE(310), 1,
      aux_sym_function_parameters_repeat1,
  [8850] = 1,
    ACTIONS(266), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [8857] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(952), 1,
      aux_sym_shebang_line_token2,
    ACTIONS(985), 1,
      sym_shebang_shell,
    STATE(349), 1,
      aux_sym_shebang_line_repeat1,
  [8870] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(987), 1,
      sym__eol,
    STATE(135), 1,
      sym__ceol,
    STATE(466), 1,
      sym_comment,
  [8883] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(989), 1,
      sym__eol,
    STATE(180), 1,
      sym__ceol,
    STATE(466), 1,
      sym_comment,
  [8896] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(991), 1,
      sym__eol,
    STATE(153), 1,
      sym__ceol,
    STATE(466), 1,
      sym_comment,
  [8909] = 1,
    ACTIONS(993), 4,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
      anon_sym_LBRACE_LBRACE,
      sym__eol,
  [8916] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(995), 1,
      sym__eol,
    STATE(169), 1,
      sym__ceol,
    STATE(466), 1,
      sym_comment,
  [8929] = 1,
    ACTIONS(258), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [8936] = 1,
    ACTIONS(282), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [8943] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(997), 1,
      sym__eol,
    STATE(179), 1,
      sym__ceol,
    STATE(466), 1,
      sym_comment,
  [8956] = 1,
    ACTIONS(270), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [8963] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(999), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1001), 1,
      aux_sym__indented_backtick_token1,
    STATE(322), 1,
      aux_sym__indented_backtick_repeat1,
  [8976] = 1,
    ACTIONS(286), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [8983] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1004), 1,
      anon_sym_COMMA,
    ACTIONS(1006), 1,
      anon_sym_RPAREN,
    STATE(326), 1,
      aux_sym_function_parameters_repeat1,
  [8996] = 1,
    ACTIONS(274), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [9003] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(147), 1,
      anon_sym_RPAREN,
    ACTIONS(1008), 1,
      anon_sym_COMMA,
    STATE(310), 1,
      aux_sym_function_parameters_repeat1,
  [9016] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(965), 1,
      aux_sym__indented_backtick_token1,
    ACTIONS(1010), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(322), 1,
      aux_sym__indented_backtick_repeat1,
  [9029] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1012), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [9040] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1016), 1,
      anon_sym_COMMA,
    ACTIONS(1018), 1,
      anon_sym_RBRACK,
    STATE(344), 1,
      aux_sym__attribute_list_repeat1,
  [9053] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(965), 1,
      aux_sym__indented_backtick_token1,
    ACTIONS(1020), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(322), 1,
      aux_sym__indented_backtick_repeat1,
  [9066] = 1,
    ACTIONS(262), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [9073] = 2,
    ACTIONS(290), 2,
      aux_sym_comment_token1,
      sym__eol,
    ACTIONS(1022), 2,
      anon_sym_PLUS,
      anon_sym_SLASH,
  [9082] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(1024), 1,
      sym__eol,
    STATE(162), 1,
      sym__ceol,
    STATE(466), 1,
      sym_comment,
  [9095] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(965), 1,
      aux_sym__indented_backtick_token1,
    ACTIONS(1026), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(330), 1,
      aux_sym__indented_backtick_repeat1,
  [9108] = 1,
    ACTIONS(240), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [9115] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(633), 1,
      sym_identifier,
    ACTIONS(639), 1,
      anon_sym_DOLLAR,
    STATE(415), 1,
      sym_recipe_parameter,
  [9128] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(965), 1,
      aux_sym__indented_backtick_token1,
    ACTIONS(1028), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(327), 1,
      aux_sym__indented_backtick_repeat1,
  [9141] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(749), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(950), 1,
      aux_sym__indented_raw_string_token1,
    STATE(303), 1,
      aux_sym__indented_raw_string_repeat1,
  [9154] = 1,
    ACTIONS(278), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [9161] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1030), 1,
      aux_sym_shebang_line_token2,
    ACTIONS(1032), 1,
      sym_shebang_shell,
    STATE(302), 1,
      aux_sym_shebang_line_repeat1,
  [9174] = 1,
    ACTIONS(1034), 4,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
      anon_sym_LBRACE_LBRACE,
      sym__eol,
  [9181] = 1,
    ACTIONS(1036), 4,
      anon_sym_LBRACE_LBRACE_LBRACE_LBRACE,
      aux_sym__recipe_line_choice_token1,
      anon_sym_LBRACE_LBRACE,
      sym__eol,
  [9188] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(491), 1,
      anon_sym_RBRACK,
    ACTIONS(1038), 1,
      anon_sym_COMMA,
    STATE(306), 1,
      aux_sym__setting_list_repeat1,
  [9201] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1016), 1,
      anon_sym_COMMA,
    ACTIONS(1040), 1,
      anon_sym_RBRACK,
    STATE(355), 1,
      aux_sym__attribute_list_repeat1,
  [9214] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(1042), 1,
      sym__eol,
    STATE(277), 1,
      sym__ceol,
    STATE(463), 1,
      sym_comment,
  [9227] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(743), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1044), 1,
      aux_sym__indented_raw_string_token1,
    STATE(338), 1,
      aux_sym__indented_raw_string_repeat1,
  [9240] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1048), 1,
      anon_sym_EQ_TILDE,
    ACTIONS(1046), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9251] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(1050), 1,
      sym__eol,
    STATE(157), 1,
      sym__ceol,
    STATE(466), 1,
      sym_comment,
  [9264] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1052), 1,
      aux_sym_shebang_line_token2,
    ACTIONS(1055), 1,
      sym_shebang_shell,
    STATE(349), 1,
      aux_sym_shebang_line_repeat1,
  [9277] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(1057), 1,
      sym__eol,
    STATE(139), 1,
      sym__ceol,
    STATE(466), 1,
      sym_comment,
  [9290] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(733), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1059), 1,
      aux_sym__indented_raw_string_token1,
    STATE(300), 1,
      aux_sym__indented_raw_string_repeat1,
  [9303] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(1061), 1,
      sym__eol,
    STATE(156), 1,
      sym__ceol,
    STATE(466), 1,
      sym_comment,
  [9316] = 1,
    ACTIONS(254), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [9323] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(290), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1063), 2,
      anon_sym_PLUS,
      anon_sym_SLASH,
  [9334] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1065), 1,
      anon_sym_COMMA,
    ACTIONS(1068), 1,
      anon_sym_RBRACK,
    STATE(355), 1,
      aux_sym__attribute_list_repeat1,
  [9347] = 4,
    ACTIONS(392), 1,
      aux_sym_comment_token1,
    ACTIONS(1070), 1,
      sym__eol,
    STATE(272), 1,
      sym__ceol,
    STATE(463), 1,
      sym_comment,
  [9360] = 4,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(954), 1,
      sym_shebang_shell,
    ACTIONS(1072), 1,
      aux_sym_shebang_line_token2,
    STATE(312), 1,
      aux_sym_shebang_line_repeat1,
  [9373] = 4,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(721), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(950), 1,
      aux_sym__indented_raw_string_token1,
    STATE(303), 1,
      aux_sym__indented_raw_string_repeat1,
  [9386] = 1,
    ACTIONS(246), 4,
      anon_sym_PLUS,
      anon_sym_SLASH,
      aux_sym_comment_token1,
      sym__eol,
  [9393] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1074), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [9401] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1076), 1,
      sym_identifier,
    ACTIONS(1078), 1,
      anon_sym_QMARK,
  [9411] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1080), 1,
      sym_identifier,
    STATE(329), 1,
      sym_attribute,
  [9421] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1082), 2,
      anon_sym_shell,
      sym_identifier,
  [9429] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1084), 1,
      sym_expansion_long_middle,
    ACTIONS(1086), 1,
      sym_expansion_long_end,
  [9439] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1088), 1,
      sym_expansion_long_middle,
    ACTIONS(1090), 1,
      sym_expansion_long_end,
  [9449] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(970), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [9457] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    STATE(423), 1,
      sym_assert_parameters,
  [9467] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1094), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [9475] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1068), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [9483] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(983), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9491] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1096), 1,
      sym_expansion_long_middle,
    ACTIONS(1098), 1,
      sym_expansion_long_end,
  [9501] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1100), 1,
      anon_sym_LPAREN,
    STATE(44), 1,
      sym_assert_parameters,
  [9511] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1080), 1,
      sym_identifier,
    STATE(369), 1,
      sym_attribute,
  [9521] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1102), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [9529] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1104), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_QMARK,
  [9539] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1108), 1,
      sym_expansion_long_middle,
    ACTIONS(1110), 1,
      sym_expansion_long_end,
  [9549] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(1112), 2,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      aux_sym__indented_backtick_token1,
  [9557] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1114), 1,
      anon_sym_LPAREN,
    STATE(393), 1,
      sym_assert_parameters,
  [9567] = 3,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1116), 1,
      sym_identifier,
    STATE(3), 1,
      sym__recipe_dependency,
  [9577] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1118), 1,
      sym_identifier,
  [9584] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1120), 1,
      sym_shell_variable_name,
  [9591] = 1,
    ACTIONS(1122), 2,
      aux_sym_comment_token1,
      sym__eol,
  [9596] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1124), 1,
      sym_identifier,
  [9603] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1126), 1,
      sym_identifier,
  [9610] = 1,
    ACTIONS(1128), 2,
      aux_sym_comment_token1,
      sym__eol,
  [9615] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(890), 1,
      anon_sym_COLON,
  [9622] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1130), 1,
      anon_sym_RPAREN,
  [9629] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1132), 1,
      sym_identifier,
  [9636] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1134), 1,
      anon_sym_RPAREN,
  [9643] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1136), 1,
      anon_sym_COLON,
  [9650] = 1,
    ACTIONS(1138), 2,
      aux_sym_comment_token1,
      sym__eol,
  [9655] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1140), 1,
      anon_sym_LBRACE,
  [9662] = 1,
    ACTIONS(197), 2,
      aux_sym_comment_token1,
      sym__eol,
  [9667] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1142), 1,
      anon_sym_COLON,
  [9674] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1144), 1,
      sym_identifier,
  [9681] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1146), 1,
      anon_sym_BQUOTE,
  [9688] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1148), 1,
      anon_sym_SQUOTE,
  [9695] = 1,
    ACTIONS(201), 2,
      aux_sym_comment_token1,
      sym__eol,
  [9700] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(1150), 1,
      aux_sym__backtick_token1,
  [9707] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1152), 1,
      anon_sym_SQUOTE,
  [9714] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1154), 1,
      anon_sym_RBRACE,
  [9721] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1156), 1,
      sym_identifier,
  [9728] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1158), 1,
      anon_sym_LBRACE,
  [9735] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(189), 1,
      anon_sym_RBRACE_RBRACE,
  [9742] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1160), 1,
      anon_sym_RBRACE,
  [9749] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1162), 1,
      anon_sym_RPAREN,
  [9756] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1164), 1,
      anon_sym_BQUOTE,
  [9763] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1166), 1,
      anon_sym_RPAREN,
  [9770] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1168), 1,
      anon_sym_RPAREN,
  [9777] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1170), 1,
      anon_sym_RPAREN,
  [9784] = 1,
    ACTIONS(193), 2,
      aux_sym_comment_token1,
      sym__eol,
  [9789] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1172), 1,
      sym_shell_variable_name,
  [9796] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(193), 1,
      anon_sym_RBRACE_RBRACE,
  [9803] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1174), 1,
      anon_sym_RBRACE,
  [9810] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1176), 1,
      anon_sym_COLON,
  [9817] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(201), 1,
      anon_sym_RBRACE_RBRACE,
  [9824] = 1,
    ACTIONS(189), 2,
      aux_sym_comment_token1,
      sym__eol,
  [9829] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1104), 1,
      sym_identifier,
  [9836] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1178), 1,
      anon_sym_LBRACE,
  [9843] = 1,
    ACTIONS(1180), 2,
      aux_sym_comment_token1,
      sym__eol,
  [9848] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1182), 1,
      anon_sym_COMMA,
  [9855] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(892), 1,
      anon_sym_COLON,
  [9862] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(197), 1,
      anon_sym_RBRACE_RBRACE,
  [9869] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1184), 1,
      anon_sym_SQUOTE,
  [9876] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1186), 1,
      anon_sym_COLON_EQ,
  [9883] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1188), 1,
      sym_identifier,
  [9890] = 1,
    ACTIONS(1190), 2,
      aux_sym_comment_token1,
      sym__eol,
  [9895] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1192), 1,
      sym_identifier,
  [9902] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1194), 1,
      anon_sym_LBRACE,
  [9909] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1196), 1,
      sym_shell_variable_name,
  [9916] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1198), 1,
      anon_sym_RPAREN,
  [9923] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1200), 1,
      anon_sym_else,
  [9930] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1202), 1,
      anon_sym_RPAREN,
  [9937] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1204), 1,
      anon_sym_BQUOTE,
  [9944] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1206), 1,
      sym_shell_variable_name,
  [9951] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1208), 1,
      sym_shell_variable_name,
  [9958] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1210), 1,
      anon_sym_RPAREN,
  [9965] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1212), 1,
      anon_sym_RPAREN,
  [9972] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1214), 1,
      anon_sym_RBRACE,
  [9979] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(1216), 1,
      aux_sym__raw_string_token1,
  [9986] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(1218), 1,
      aux_sym__raw_string_token1,
  [9993] = 1,
    ACTIONS(1220), 2,
      aux_sym_comment_token1,
      sym__eol,
  [9998] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(1222), 1,
      aux_sym__backtick_token1,
  [10005] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1224), 1,
      anon_sym_RBRACE_RBRACE,
  [10012] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1226), 1,
      sym_shell_variable_name,
  [10019] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(1228), 1,
      aux_sym__raw_string_token1,
  [10026] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1230), 1,
      anon_sym_COLON_EQ,
  [10033] = 2,
    ACTIONS(304), 1,
      sym__eol,
    ACTIONS(1232), 1,
      aux_sym__backtick_token1,
  [10040] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1234), 1,
      anon_sym_COLON_EQ,
  [10047] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1236), 1,
      anon_sym_COLON,
  [10054] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1238), 1,
      anon_sym_COMMA,
  [10061] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1240), 1,
      anon_sym_LBRACE,
  [10068] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1242), 1,
      anon_sym_COMMA,
  [10075] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1244), 1,
      anon_sym_LBRACE,
  [10082] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1246), 1,
      ts_builtin_sym_end,
  [10089] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1248), 1,
      anon_sym_else,
  [10096] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1250), 1,
      sym_shell_variable_name,
  [10103] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1252), 1,
      anon_sym_else,
  [10110] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1254), 1,
      anon_sym_RBRACE,
  [10117] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
  [10124] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1258), 1,
      sym_shell_variable_name,
  [10131] = 2,
    ACTIONS(3), 1,
      sym__eol,
    ACTIONS(1260), 1,
      sym_identifier,
  [10138] = 1,
    ACTIONS(1262), 1,
      sym__eol,
  [10142] = 1,
    ACTIONS(1264), 1,
      sym__eol,
  [10146] = 1,
    ACTIONS(629), 1,
      sym__eol,
  [10150] = 1,
    ACTIONS(1266), 1,
      sym__eol,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 76,
  [SMALL_STATE(4)] = 150,
  [SMALL_STATE(5)] = 226,
  [SMALL_STATE(6)] = 302,
  [SMALL_STATE(7)] = 376,
  [SMALL_STATE(8)] = 450,
  [SMALL_STATE(9)] = 523,
  [SMALL_STATE(10)] = 596,
  [SMALL_STATE(11)] = 669,
  [SMALL_STATE(12)] = 742,
  [SMALL_STATE(13)] = 815,
  [SMALL_STATE(14)] = 888,
  [SMALL_STATE(15)] = 961,
  [SMALL_STATE(16)] = 1034,
  [SMALL_STATE(17)] = 1104,
  [SMALL_STATE(18)] = 1174,
  [SMALL_STATE(19)] = 1244,
  [SMALL_STATE(20)] = 1314,
  [SMALL_STATE(21)] = 1384,
  [SMALL_STATE(22)] = 1454,
  [SMALL_STATE(23)] = 1524,
  [SMALL_STATE(24)] = 1594,
  [SMALL_STATE(25)] = 1664,
  [SMALL_STATE(26)] = 1734,
  [SMALL_STATE(27)] = 1804,
  [SMALL_STATE(28)] = 1874,
  [SMALL_STATE(29)] = 1944,
  [SMALL_STATE(30)] = 2014,
  [SMALL_STATE(31)] = 2084,
  [SMALL_STATE(32)] = 2154,
  [SMALL_STATE(33)] = 2224,
  [SMALL_STATE(34)] = 2294,
  [SMALL_STATE(35)] = 2364,
  [SMALL_STATE(36)] = 2434,
  [SMALL_STATE(37)] = 2504,
  [SMALL_STATE(38)] = 2574,
  [SMALL_STATE(39)] = 2644,
  [SMALL_STATE(40)] = 2714,
  [SMALL_STATE(41)] = 2784,
  [SMALL_STATE(42)] = 2854,
  [SMALL_STATE(43)] = 2885,
  [SMALL_STATE(44)] = 2916,
  [SMALL_STATE(45)] = 2947,
  [SMALL_STATE(46)] = 2978,
  [SMALL_STATE(47)] = 3036,
  [SMALL_STATE(48)] = 3094,
  [SMALL_STATE(49)] = 3142,
  [SMALL_STATE(50)] = 3190,
  [SMALL_STATE(51)] = 3217,
  [SMALL_STATE(52)] = 3244,
  [SMALL_STATE(53)] = 3273,
  [SMALL_STATE(54)] = 3300,
  [SMALL_STATE(55)] = 3327,
  [SMALL_STATE(56)] = 3354,
  [SMALL_STATE(57)] = 3381,
  [SMALL_STATE(58)] = 3408,
  [SMALL_STATE(59)] = 3435,
  [SMALL_STATE(60)] = 3462,
  [SMALL_STATE(61)] = 3489,
  [SMALL_STATE(62)] = 3516,
  [SMALL_STATE(63)] = 3543,
  [SMALL_STATE(64)] = 3570,
  [SMALL_STATE(65)] = 3598,
  [SMALL_STATE(66)] = 3623,
  [SMALL_STATE(67)] = 3654,
  [SMALL_STATE(68)] = 3685,
  [SMALL_STATE(69)] = 3716,
  [SMALL_STATE(70)] = 3747,
  [SMALL_STATE(71)] = 3778,
  [SMALL_STATE(72)] = 3809,
  [SMALL_STATE(73)] = 3840,
  [SMALL_STATE(74)] = 3871,
  [SMALL_STATE(75)] = 3902,
  [SMALL_STATE(76)] = 3933,
  [SMALL_STATE(77)] = 3964,
  [SMALL_STATE(78)] = 3995,
  [SMALL_STATE(79)] = 4026,
  [SMALL_STATE(80)] = 4057,
  [SMALL_STATE(81)] = 4088,
  [SMALL_STATE(82)] = 4108,
  [SMALL_STATE(83)] = 4128,
  [SMALL_STATE(84)] = 4148,
  [SMALL_STATE(85)] = 4192,
  [SMALL_STATE(86)] = 4212,
  [SMALL_STATE(87)] = 4234,
  [SMALL_STATE(88)] = 4254,
  [SMALL_STATE(89)] = 4285,
  [SMALL_STATE(90)] = 4304,
  [SMALL_STATE(91)] = 4329,
  [SMALL_STATE(92)] = 4348,
  [SMALL_STATE(93)] = 4379,
  [SMALL_STATE(94)] = 4410,
  [SMALL_STATE(95)] = 4429,
  [SMALL_STATE(96)] = 4472,
  [SMALL_STATE(97)] = 4491,
  [SMALL_STATE(98)] = 4534,
  [SMALL_STATE(99)] = 4559,
  [SMALL_STATE(100)] = 4584,
  [SMALL_STATE(101)] = 4615,
  [SMALL_STATE(102)] = 4658,
  [SMALL_STATE(103)] = 4689,
  [SMALL_STATE(104)] = 4720,
  [SMALL_STATE(105)] = 4739,
  [SMALL_STATE(106)] = 4758,
  [SMALL_STATE(107)] = 4789,
  [SMALL_STATE(108)] = 4808,
  [SMALL_STATE(109)] = 4827,
  [SMALL_STATE(110)] = 4852,
  [SMALL_STATE(111)] = 4882,
  [SMALL_STATE(112)] = 4912,
  [SMALL_STATE(113)] = 4942,
  [SMALL_STATE(114)] = 4972,
  [SMALL_STATE(115)] = 5002,
  [SMALL_STATE(116)] = 5032,
  [SMALL_STATE(117)] = 5062,
  [SMALL_STATE(118)] = 5081,
  [SMALL_STATE(119)] = 5118,
  [SMALL_STATE(120)] = 5137,
  [SMALL_STATE(121)] = 5156,
  [SMALL_STATE(122)] = 5175,
  [SMALL_STATE(123)] = 5194,
  [SMALL_STATE(124)] = 5213,
  [SMALL_STATE(125)] = 5250,
  [SMALL_STATE(126)] = 5269,
  [SMALL_STATE(127)] = 5288,
  [SMALL_STATE(128)] = 5317,
  [SMALL_STATE(129)] = 5354,
  [SMALL_STATE(130)] = 5373,
  [SMALL_STATE(131)] = 5392,
  [SMALL_STATE(132)] = 5411,
  [SMALL_STATE(133)] = 5429,
  [SMALL_STATE(134)] = 5447,
  [SMALL_STATE(135)] = 5481,
  [SMALL_STATE(136)] = 5499,
  [SMALL_STATE(137)] = 5517,
  [SMALL_STATE(138)] = 5535,
  [SMALL_STATE(139)] = 5553,
  [SMALL_STATE(140)] = 5571,
  [SMALL_STATE(141)] = 5589,
  [SMALL_STATE(142)] = 5607,
  [SMALL_STATE(143)] = 5625,
  [SMALL_STATE(144)] = 5643,
  [SMALL_STATE(145)] = 5661,
  [SMALL_STATE(146)] = 5683,
  [SMALL_STATE(147)] = 5705,
  [SMALL_STATE(148)] = 5721,
  [SMALL_STATE(149)] = 5755,
  [SMALL_STATE(150)] = 5773,
  [SMALL_STATE(151)] = 5791,
  [SMALL_STATE(152)] = 5809,
  [SMALL_STATE(153)] = 5827,
  [SMALL_STATE(154)] = 5845,
  [SMALL_STATE(155)] = 5869,
  [SMALL_STATE(156)] = 5887,
  [SMALL_STATE(157)] = 5905,
  [SMALL_STATE(158)] = 5923,
  [SMALL_STATE(159)] = 5939,
  [SMALL_STATE(160)] = 5957,
  [SMALL_STATE(161)] = 5979,
  [SMALL_STATE(162)] = 5997,
  [SMALL_STATE(163)] = 6015,
  [SMALL_STATE(164)] = 6033,
  [SMALL_STATE(165)] = 6067,
  [SMALL_STATE(166)] = 6083,
  [SMALL_STATE(167)] = 6101,
  [SMALL_STATE(168)] = 6123,
  [SMALL_STATE(169)] = 6141,
  [SMALL_STATE(170)] = 6159,
  [SMALL_STATE(171)] = 6175,
  [SMALL_STATE(172)] = 6197,
  [SMALL_STATE(173)] = 6215,
  [SMALL_STATE(174)] = 6237,
  [SMALL_STATE(175)] = 6253,
  [SMALL_STATE(176)] = 6271,
  [SMALL_STATE(177)] = 6305,
  [SMALL_STATE(178)] = 6323,
  [SMALL_STATE(179)] = 6355,
  [SMALL_STATE(180)] = 6373,
  [SMALL_STATE(181)] = 6391,
  [SMALL_STATE(182)] = 6420,
  [SMALL_STATE(183)] = 6449,
  [SMALL_STATE(184)] = 6464,
  [SMALL_STATE(185)] = 6485,
  [SMALL_STATE(186)] = 6500,
  [SMALL_STATE(187)] = 6529,
  [SMALL_STATE(188)] = 6558,
  [SMALL_STATE(189)] = 6587,
  [SMALL_STATE(190)] = 6616,
  [SMALL_STATE(191)] = 6637,
  [SMALL_STATE(192)] = 6652,
  [SMALL_STATE(193)] = 6673,
  [SMALL_STATE(194)] = 6702,
  [SMALL_STATE(195)] = 6723,
  [SMALL_STATE(196)] = 6752,
  [SMALL_STATE(197)] = 6781,
  [SMALL_STATE(198)] = 6798,
  [SMALL_STATE(199)] = 6827,
  [SMALL_STATE(200)] = 6856,
  [SMALL_STATE(201)] = 6877,
  [SMALL_STATE(202)] = 6898,
  [SMALL_STATE(203)] = 6919,
  [SMALL_STATE(204)] = 6934,
  [SMALL_STATE(205)] = 6955,
  [SMALL_STATE(206)] = 6984,
  [SMALL_STATE(207)] = 7005,
  [SMALL_STATE(208)] = 7026,
  [SMALL_STATE(209)] = 7055,
  [SMALL_STATE(210)] = 7084,
  [SMALL_STATE(211)] = 7099,
  [SMALL_STATE(212)] = 7120,
  [SMALL_STATE(213)] = 7141,
  [SMALL_STATE(214)] = 7162,
  [SMALL_STATE(215)] = 7183,
  [SMALL_STATE(216)] = 7209,
  [SMALL_STATE(217)] = 7235,
  [SMALL_STATE(218)] = 7261,
  [SMALL_STATE(219)] = 7287,
  [SMALL_STATE(220)] = 7313,
  [SMALL_STATE(221)] = 7339,
  [SMALL_STATE(222)] = 7365,
  [SMALL_STATE(223)] = 7391,
  [SMALL_STATE(224)] = 7407,
  [SMALL_STATE(225)] = 7423,
  [SMALL_STATE(226)] = 7449,
  [SMALL_STATE(227)] = 7475,
  [SMALL_STATE(228)] = 7501,
  [SMALL_STATE(229)] = 7527,
  [SMALL_STATE(230)] = 7553,
  [SMALL_STATE(231)] = 7579,
  [SMALL_STATE(232)] = 7605,
  [SMALL_STATE(233)] = 7631,
  [SMALL_STATE(234)] = 7657,
  [SMALL_STATE(235)] = 7683,
  [SMALL_STATE(236)] = 7706,
  [SMALL_STATE(237)] = 7725,
  [SMALL_STATE(238)] = 7746,
  [SMALL_STATE(239)] = 7759,
  [SMALL_STATE(240)] = 7778,
  [SMALL_STATE(241)] = 7801,
  [SMALL_STATE(242)] = 7822,
  [SMALL_STATE(243)] = 7835,
  [SMALL_STATE(244)] = 7849,
  [SMALL_STATE(245)] = 7867,
  [SMALL_STATE(246)] = 7889,
  [SMALL_STATE(247)] = 7911,
  [SMALL_STATE(248)] = 7933,
  [SMALL_STATE(249)] = 7955,
  [SMALL_STATE(250)] = 7977,
  [SMALL_STATE(251)] = 7999,
  [SMALL_STATE(252)] = 8017,
  [SMALL_STATE(253)] = 8035,
  [SMALL_STATE(254)] = 8057,
  [SMALL_STATE(255)] = 8071,
  [SMALL_STATE(256)] = 8089,
  [SMALL_STATE(257)] = 8107,
  [SMALL_STATE(258)] = 8129,
  [SMALL_STATE(259)] = 8151,
  [SMALL_STATE(260)] = 8169,
  [SMALL_STATE(261)] = 8187,
  [SMALL_STATE(262)] = 8205,
  [SMALL_STATE(263)] = 8223,
  [SMALL_STATE(264)] = 8241,
  [SMALL_STATE(265)] = 8263,
  [SMALL_STATE(266)] = 8285,
  [SMALL_STATE(267)] = 8307,
  [SMALL_STATE(268)] = 8325,
  [SMALL_STATE(269)] = 8343,
  [SMALL_STATE(270)] = 8365,
  [SMALL_STATE(271)] = 8387,
  [SMALL_STATE(272)] = 8398,
  [SMALL_STATE(273)] = 8411,
  [SMALL_STATE(274)] = 8424,
  [SMALL_STATE(275)] = 8437,
  [SMALL_STATE(276)] = 8450,
  [SMALL_STATE(277)] = 8461,
  [SMALL_STATE(278)] = 8474,
  [SMALL_STATE(279)] = 8487,
  [SMALL_STATE(280)] = 8500,
  [SMALL_STATE(281)] = 8508,
  [SMALL_STATE(282)] = 8518,
  [SMALL_STATE(283)] = 8532,
  [SMALL_STATE(284)] = 8542,
  [SMALL_STATE(285)] = 8556,
  [SMALL_STATE(286)] = 8566,
  [SMALL_STATE(287)] = 8576,
  [SMALL_STATE(288)] = 8584,
  [SMALL_STATE(289)] = 8594,
  [SMALL_STATE(290)] = 8604,
  [SMALL_STATE(291)] = 8614,
  [SMALL_STATE(292)] = 8622,
  [SMALL_STATE(293)] = 8632,
  [SMALL_STATE(294)] = 8646,
  [SMALL_STATE(295)] = 8656,
  [SMALL_STATE(296)] = 8670,
  [SMALL_STATE(297)] = 8684,
  [SMALL_STATE(298)] = 8698,
  [SMALL_STATE(299)] = 8706,
  [SMALL_STATE(300)] = 8713,
  [SMALL_STATE(301)] = 8726,
  [SMALL_STATE(302)] = 8733,
  [SMALL_STATE(303)] = 8746,
  [SMALL_STATE(304)] = 8759,
  [SMALL_STATE(305)] = 8772,
  [SMALL_STATE(306)] = 8785,
  [SMALL_STATE(307)] = 8798,
  [SMALL_STATE(308)] = 8811,
  [SMALL_STATE(309)] = 8824,
  [SMALL_STATE(310)] = 8837,
  [SMALL_STATE(311)] = 8850,
  [SMALL_STATE(312)] = 8857,
  [SMALL_STATE(313)] = 8870,
  [SMALL_STATE(314)] = 8883,
  [SMALL_STATE(315)] = 8896,
  [SMALL_STATE(316)] = 8909,
  [SMALL_STATE(317)] = 8916,
  [SMALL_STATE(318)] = 8929,
  [SMALL_STATE(319)] = 8936,
  [SMALL_STATE(320)] = 8943,
  [SMALL_STATE(321)] = 8956,
  [SMALL_STATE(322)] = 8963,
  [SMALL_STATE(323)] = 8976,
  [SMALL_STATE(324)] = 8983,
  [SMALL_STATE(325)] = 8996,
  [SMALL_STATE(326)] = 9003,
  [SMALL_STATE(327)] = 9016,
  [SMALL_STATE(328)] = 9029,
  [SMALL_STATE(329)] = 9040,
  [SMALL_STATE(330)] = 9053,
  [SMALL_STATE(331)] = 9066,
  [SMALL_STATE(332)] = 9073,
  [SMALL_STATE(333)] = 9082,
  [SMALL_STATE(334)] = 9095,
  [SMALL_STATE(335)] = 9108,
  [SMALL_STATE(336)] = 9115,
  [SMALL_STATE(337)] = 9128,
  [SMALL_STATE(338)] = 9141,
  [SMALL_STATE(339)] = 9154,
  [SMALL_STATE(340)] = 9161,
  [SMALL_STATE(341)] = 9174,
  [SMALL_STATE(342)] = 9181,
  [SMALL_STATE(343)] = 9188,
  [SMALL_STATE(344)] = 9201,
  [SMALL_STATE(345)] = 9214,
  [SMALL_STATE(346)] = 9227,
  [SMALL_STATE(347)] = 9240,
  [SMALL_STATE(348)] = 9251,
  [SMALL_STATE(349)] = 9264,
  [SMALL_STATE(350)] = 9277,
  [SMALL_STATE(351)] = 9290,
  [SMALL_STATE(352)] = 9303,
  [SMALL_STATE(353)] = 9316,
  [SMALL_STATE(354)] = 9323,
  [SMALL_STATE(355)] = 9334,
  [SMALL_STATE(356)] = 9347,
  [SMALL_STATE(357)] = 9360,
  [SMALL_STATE(358)] = 9373,
  [SMALL_STATE(359)] = 9386,
  [SMALL_STATE(360)] = 9393,
  [SMALL_STATE(361)] = 9401,
  [SMALL_STATE(362)] = 9411,
  [SMALL_STATE(363)] = 9421,
  [SMALL_STATE(364)] = 9429,
  [SMALL_STATE(365)] = 9439,
  [SMALL_STATE(366)] = 9449,
  [SMALL_STATE(367)] = 9457,
  [SMALL_STATE(368)] = 9467,
  [SMALL_STATE(369)] = 9475,
  [SMALL_STATE(370)] = 9483,
  [SMALL_STATE(371)] = 9491,
  [SMALL_STATE(372)] = 9501,
  [SMALL_STATE(373)] = 9511,
  [SMALL_STATE(374)] = 9521,
  [SMALL_STATE(375)] = 9529,
  [SMALL_STATE(376)] = 9539,
  [SMALL_STATE(377)] = 9549,
  [SMALL_STATE(378)] = 9557,
  [SMALL_STATE(379)] = 9567,
  [SMALL_STATE(380)] = 9577,
  [SMALL_STATE(381)] = 9584,
  [SMALL_STATE(382)] = 9591,
  [SMALL_STATE(383)] = 9596,
  [SMALL_STATE(384)] = 9603,
  [SMALL_STATE(385)] = 9610,
  [SMALL_STATE(386)] = 9615,
  [SMALL_STATE(387)] = 9622,
  [SMALL_STATE(388)] = 9629,
  [SMALL_STATE(389)] = 9636,
  [SMALL_STATE(390)] = 9643,
  [SMALL_STATE(391)] = 9650,
  [SMALL_STATE(392)] = 9655,
  [SMALL_STATE(393)] = 9662,
  [SMALL_STATE(394)] = 9667,
  [SMALL_STATE(395)] = 9674,
  [SMALL_STATE(396)] = 9681,
  [SMALL_STATE(397)] = 9688,
  [SMALL_STATE(398)] = 9695,
  [SMALL_STATE(399)] = 9700,
  [SMALL_STATE(400)] = 9707,
  [SMALL_STATE(401)] = 9714,
  [SMALL_STATE(402)] = 9721,
  [SMALL_STATE(403)] = 9728,
  [SMALL_STATE(404)] = 9735,
  [SMALL_STATE(405)] = 9742,
  [SMALL_STATE(406)] = 9749,
  [SMALL_STATE(407)] = 9756,
  [SMALL_STATE(408)] = 9763,
  [SMALL_STATE(409)] = 9770,
  [SMALL_STATE(410)] = 9777,
  [SMALL_STATE(411)] = 9784,
  [SMALL_STATE(412)] = 9789,
  [SMALL_STATE(413)] = 9796,
  [SMALL_STATE(414)] = 9803,
  [SMALL_STATE(415)] = 9810,
  [SMALL_STATE(416)] = 9817,
  [SMALL_STATE(417)] = 9824,
  [SMALL_STATE(418)] = 9829,
  [SMALL_STATE(419)] = 9836,
  [SMALL_STATE(420)] = 9843,
  [SMALL_STATE(421)] = 9848,
  [SMALL_STATE(422)] = 9855,
  [SMALL_STATE(423)] = 9862,
  [SMALL_STATE(424)] = 9869,
  [SMALL_STATE(425)] = 9876,
  [SMALL_STATE(426)] = 9883,
  [SMALL_STATE(427)] = 9890,
  [SMALL_STATE(428)] = 9895,
  [SMALL_STATE(429)] = 9902,
  [SMALL_STATE(430)] = 9909,
  [SMALL_STATE(431)] = 9916,
  [SMALL_STATE(432)] = 9923,
  [SMALL_STATE(433)] = 9930,
  [SMALL_STATE(434)] = 9937,
  [SMALL_STATE(435)] = 9944,
  [SMALL_STATE(436)] = 9951,
  [SMALL_STATE(437)] = 9958,
  [SMALL_STATE(438)] = 9965,
  [SMALL_STATE(439)] = 9972,
  [SMALL_STATE(440)] = 9979,
  [SMALL_STATE(441)] = 9986,
  [SMALL_STATE(442)] = 9993,
  [SMALL_STATE(443)] = 9998,
  [SMALL_STATE(444)] = 10005,
  [SMALL_STATE(445)] = 10012,
  [SMALL_STATE(446)] = 10019,
  [SMALL_STATE(447)] = 10026,
  [SMALL_STATE(448)] = 10033,
  [SMALL_STATE(449)] = 10040,
  [SMALL_STATE(450)] = 10047,
  [SMALL_STATE(451)] = 10054,
  [SMALL_STATE(452)] = 10061,
  [SMALL_STATE(453)] = 10068,
  [SMALL_STATE(454)] = 10075,
  [SMALL_STATE(455)] = 10082,
  [SMALL_STATE(456)] = 10089,
  [SMALL_STATE(457)] = 10096,
  [SMALL_STATE(458)] = 10103,
  [SMALL_STATE(459)] = 10110,
  [SMALL_STATE(460)] = 10117,
  [SMALL_STATE(461)] = 10124,
  [SMALL_STATE(462)] = 10131,
  [SMALL_STATE(463)] = 10138,
  [SMALL_STATE(464)] = 10142,
  [SMALL_STATE(465)] = 10146,
  [SMALL_STATE(466)] = 10150,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [95] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(52),
  [98] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(25),
  [101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0),
  [103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(9),
  [106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(372),
  [109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(23),
  [112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(448),
  [115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(307),
  [118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(207),
  [121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(206),
  [124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(351),
  [127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(100),
  [133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(112),
  [136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(257),
  [139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(249),
  [142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_dependency_repeat1, 2, 0, 0), SHIFT_REPEAT(51),
  [145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 3, 0, 0),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 2, 0, 0),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_parameters, 5, 0, 0),
  [189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_parameters, 5, 0, 0),
  [191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 3, 0, 0),
  [193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 3, 0, 0),
  [195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 2, 0, 0),
  [197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 2, 0, 0),
  [199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 9, 0, 0),
  [201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 9, 0, 0),
  [203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(178),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(380),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(388),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(128),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(361),
  [220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(462),
  [223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(362),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(363),
  [229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(177),
  [232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file, 1, 0, 0),
  [234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shell_expanded_string, 3, 0, 0),
  [236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shell_expanded_string, 3, 0, 0),
  [238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 1, 0, 0),
  [240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 1, 0, 0),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shell_expanded_string, 2, 0, 0),
  [246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shell_expanded_string, 2, 0, 0),
  [248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__backtick, 3, 0, 0),
  [250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__backtick, 3, 0, 0),
  [252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_command, 1, 0, 0),
  [262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_command, 1, 0, 0),
  [264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__indented_backtick, 3, 0, 10),
  [270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__indented_backtick, 3, 0, 10),
  [272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 4, 0, 1),
  [274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 4, 0, 1),
  [276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__indented_backtick, 2, 0, 0),
  [278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__indented_backtick, 2, 0, 0),
  [280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 3, 0, 0),
  [282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 3, 0, 0),
  [284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 3, 0, 1),
  [286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 3, 0, 1),
  [288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__recipe_dependency, 1, 0, 1),
  [296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__recipe_dependency, 1, 0, 1),
  [298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 5, 0, 1),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 5, 0, 1),
  [302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 5, 0, 6),
  [308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 5, 0, 6),
  [310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 7, 0, 3),
  [312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 7, 0, 3),
  [314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 7, 0, 1),
  [316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 7, 0, 1),
  [318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 7, 0, 6),
  [320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 7, 0, 6),
  [322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 8, 0, 3),
  [324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 8, 0, 3),
  [326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 6, 0, 1),
  [328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 6, 0, 1),
  [330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 9, 0, 6),
  [332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 9, 0, 6),
  [334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 5, 0, 3),
  [336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 5, 0, 3),
  [338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 3, 0, 1),
  [340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 3, 0, 1),
  [342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 6, 0, 6),
  [344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 6, 0, 6),
  [346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 4, 0, 1),
  [348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 4, 0, 1),
  [350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 4, 0, 3),
  [352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 4, 0, 3),
  [354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 8, 0, 6),
  [356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 8, 0, 6),
  [358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 6, 0, 3),
  [360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 6, 0, 3),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_body, 1, 0, 0),
  [380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe_body, 1, 0, 0),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_body, 1, 0, 8),
  [400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe_body, 1, 0, 8),
  [402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_body, 2, 0, 8),
  [404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe_body, 2, 0, 8),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat2, 2, 0, 0), SHIFT_REPEAT(125),
  [415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat2, 2, 0, 0),
  [417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat2, 2, 0, 0), SHIFT_REPEAT(174),
  [420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat2, 2, 0, 0), SHIFT_REPEAT(102),
  [423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat2, 2, 0, 0), SHIFT_REPEAT(412),
  [426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_recipe_body_repeat1, 2, 0, 0),
  [432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_recipe_body_repeat1, 2, 0, 0),
  [434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_body_repeat1, 2, 0, 0), SHIFT_REPEAT(154),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat2, 2, 0, 0), SHIFT_REPEAT(172),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat2, 2, 0, 0),
  [442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat2, 2, 0, 0), SHIFT_REPEAT(210),
  [445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat2, 2, 0, 0), SHIFT_REPEAT(110),
  [448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat2, 2, 0, 0), SHIFT_REPEAT(461),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shebang_line, 7, 0, 23),
  [467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shebang_line, 7, 0, 23),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shebang_line, 5, 0, 21),
  [473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shebang_line, 5, 0, 21),
  [475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shebang_line, 6, 0, 0),
  [477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shebang_line, 6, 0, 0),
  [479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shebang_line, 5, 0, 0),
  [481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shebang_line, 5, 0, 0),
  [483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shebang_line, 6, 0, 22),
  [485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shebang_line, 6, 0, 22),
  [487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_line, 3, 0, 16),
  [489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe_line, 3, 0, 16),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat2, 1, 0, 0),
  [495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expansion_short_start, 1, 0, 0),
  [497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ceol, 2, 0, 0),
  [499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ceol, 2, 0, 0),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_line, 4, 0, 19),
  [515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe_line, 4, 0, 19),
  [517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shebang_line, 4, 0, 0),
  [519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shebang_line, 4, 0, 0),
  [521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 8, 0, 1),
  [523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 8, 0, 1),
  [525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 5, 0, 3),
  [527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 5, 0, 3),
  [529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod, 4, 0, 6),
  [531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod, 4, 0, 6),
  [533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod, 4, 0, 7),
  [535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod, 4, 0, 7),
  [537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 9, 0, 3),
  [539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 9, 0, 3),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat2, 4, 0, 0),
  [555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod, 5, 0, 14),
  [557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod, 5, 0, 14),
  [559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setting, 4, 0, 3),
  [561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setting, 4, 0, 3),
  [563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod, 6, 0, 18),
  [565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod, 6, 0, 18),
  [567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, 0, 5),
  [569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 4, 0, 5),
  [571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 6, 0, 6),
  [573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 6, 0, 6),
  [575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat2, 5, 0, 0),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 10, 0, 6),
  [583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recipe, 10, 0, 6),
  [585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 4, 0, 1),
  [587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 4, 0, 1),
  [589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setting, 3, 0, 3),
  [591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setting, 3, 0, 3),
  [593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat2, 3, 0, 0),
  [595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod, 3, 0, 3),
  [597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod, 3, 0, 3),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat1, 2, 0, 0), SHIFT_REPEAT(224),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat1, 2, 0, 0), SHIFT_REPEAT(167),
  [605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__shell_expanded_indented_normal_string_repeat1, 2, 0, 0),
  [607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 3, 0, 2),
  [609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 3, 0, 2),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat2, 1, 0, 0),
  [617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expansion_short_start, 1, 0, 0),
  [619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat1, 2, 0, 0), SHIFT_REPEAT(223),
  [622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat1, 2, 0, 0), SHIFT_REPEAT(173),
  [625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat1, 2, 0, 0),
  [627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_escape_sequence, 1, 0, 0),
  [629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 1, 0, 0),
  [631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comment, 1, 0, 0),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod, 5, 0, 9),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod, 5, 0, 9),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 5, 0, 3),
  [649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 5, 0, 3),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat2, 5, 0, 0),
  [665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__normal_string_repeat1, 2, 0, 0),
  [667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__normal_string_repeat1, 2, 0, 0), SHIFT_REPEAT(184),
  [670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__normal_string_repeat1, 2, 0, 0), SHIFT_REPEAT(242),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat2, 3, 0, 0),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__indented_normal_string_repeat1, 2, 0, 0),
  [705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__indented_normal_string_repeat1, 2, 0, 0), SHIFT_REPEAT(194),
  [708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__indented_normal_string_repeat1, 2, 0, 0), SHIFT_REPEAT(238),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_normal_string_repeat2, 4, 0, 0),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_escape_sequence, 1, 0, 0),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_alias_repeat1, 2, 0, 0),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alias_repeat1, 2, 0, 0),
  [769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_repeat1, 2, 0, 0), SHIFT_REPEAT(362),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(280),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0),
  [781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_repeat1, 2, 0, 0), SHIFT_REPEAT(379),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_parameter, 2, 0, 3),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_parameter, 1, 0, 1),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(254),
  [833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(402),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_recipe_parameters_repeat1, 2, 0, 0),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_raw_string_repeat2, 2, 0, 0), SHIFT_REPEAT(278),
  [851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_raw_string_repeat2, 2, 0, 0),
  [853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_raw_string_repeat2, 2, 0, 0), SHIFT_REPEAT(266),
  [856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_raw_string_repeat2, 2, 0, 0), SHIFT_REPEAT(435),
  [859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_shebang_line_repeat2, 2, 0, 17), SHIFT_REPEAT(341),
  [862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_shebang_line_repeat2, 2, 0, 17), SHIFT_REPEAT(34),
  [865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_shebang_line_repeat2, 2, 0, 17),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_raw_string_repeat2, 2, 0, 0), SHIFT_REPEAT(279),
  [872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_raw_string_repeat2, 2, 0, 0),
  [874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_raw_string_repeat2, 2, 0, 0), SHIFT_REPEAT(269),
  [877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_raw_string_repeat2, 2, 0, 0), SHIFT_REPEAT(445),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_parameter, 4, 0, 3),
  [884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_list, 5, 0, 0),
  [886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_list, 5, 0, 0),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_recipe_parameters_repeat1, 1, 0, 0),
  [890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_parameters, 1, 0, 0),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_parameters, 2, 0, 0),
  [894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_parameter, 3, 0, 1),
  [896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_list, 4, 0, 0),
  [898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_list, 4, 0, 0),
  [900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_raw_string_repeat2, 1, 0, 0),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_raw_string_repeat2, 1, 0, 0),
  [904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_raw_string_repeat2, 4, 0, 0),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_raw_string_repeat2, 3, 0, 0),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_raw_string_repeat2, 3, 0, 0),
  [918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_dependency, 3, 0, 11),
  [920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_raw_string_repeat2, 4, 0, 0),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_dependency, 4, 0, 11),
  [926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_raw_string_repeat2, 5, 0, 0),
  [928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_indented_raw_string_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__shell_expanded_indented_raw_string_repeat1, 2, 0, 0),
  [933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__shell_expanded_raw_string_repeat2, 5, 0, 0),
  [935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__shell_expanded_raw_string_repeat1, 2, 0, 0), SHIFT_REPEAT(295),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__shell_expanded_raw_string_repeat1, 2, 0, 0),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe_dependency, 1, 0, 4),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__indented_raw_string_repeat1, 2, 0, 0),
  [958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__indented_raw_string_repeat1, 2, 0, 0), SHIFT_REPEAT(303),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__setting_list_repeat1, 2, 0, 0), SHIFT_REPEAT(134),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__setting_list_repeat1, 2, 0, 0),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(27),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 2, 0, 0),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, 0, 20),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__indented_backtick_repeat1, 2, 0, 0),
  [1001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__indented_backtick_repeat1, 2, 0, 0), SHIFT_REPEAT(377),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 1, 0, 0),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 1),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__recipe_line_choice, 1, 0, 12),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_shebang_line_repeat2, 1, 0, 13),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_shebang_line_repeat1, 2, 0, 0), SHIFT_REPEAT(349),
  [1055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_shebang_line_repeat1, 2, 0, 0),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_list_repeat1, 2, 0, 0), SHIFT_REPEAT(373),
  [1068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_list_repeat1, 2, 0, 0),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition, 3, 0, 15),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 1),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition, 3, 0, 0),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__indented_backtick_repeat1, 1, 0, 0),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setting_boolean, 2, 0, 0),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setting_string, 2, 0, 0),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setting_list, 4, 0, 0),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [1176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 2, 0, 0),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setting_list, 6, 0, 0),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [1192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setting_list, 5, 0, 0),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1246] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_just(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
